<?php
/*
 * Kann auf Basis eines Pop3 Accounts Emailrcklufer aussortieren.
 *
 * @author (c) Bjrn Brockmann 2008
 * 
 */


class NlBounce
{
	
	//config values
	var $cfg = array();
	
	//internal, private values
	var $prv = array(
					'msg_error' => '',
					'regex_email' => '((\"[^\"\f\n\r\t\v\b]+\")|([\w\!\#\$\%\&\'\*\+\-\~\/\^\`\|\{\}]+(\.[\w\!\#\$\%\&\'\*\+\-\~\/\^\`\|\{\}]+)*))@((\[(((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9])))\])|(((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9])))|((([A-Za-z0-9\-])+\.)+[A-Za-z\-]+))',
					);
	
	//messages
	var $msgs = array();
	
	//single message
	var $msg = array(
					'index' => '',
					'bytesize' => '',
					'uid' => '',
					'arr_headers' => '',
					'arr_body' => '',
					'txt_body' => '',
					'from' => '',
					'from_email' => '',
					'from_name' => '',
					'to' => '',
					'to_email' => '',
					'to_name' => '',
					'subject' => '',
					'is_bounce' => FALSE,
					);
	
	//emailadressen der gefundenen bounces
	var $bouncemails = array();
	
	var $whitelist_subject = array( 'auer haus',
			                            'au=dfer haus',
                                        'abwesenheitsnotiz', 
                                        'abwesend', 
                                        'rponse automatique',
                                        'r=e9ponse automatique',
                                        'autoresponder',
                                        'auto response',
                                        'autoreply',
                                        'auto-reply',
                                        'out of office',
                                        'subscription confirmation',
                                        'sommerpause',
                                        'winterpause',
                                        'summer break',
                                        'winter break',
                                        'business trip',
                                        );
    
    var $whitelist_body = array( 'auer haus',
			                         'nicht im bro',
			                         'nicht besetzt',
			                         'betriebsferien',
                                        'abwesenheitsnotiz', 
                                        'abwesend', 
                                        'rponse automatique',
                                        'autoresponder',
                                        'auto response',
                                        'autoreply',
                                        'auto-reply',
                                        'out of office',
                                        'out of the office',
                                        'sommerpause',
                                        'winterpause',
                                        'summer break',
                                        'winter break',
                                        );
	
	
	
	/**
	 * Konstruktor. 
	 * Initialisiert pop3 Klasse und setzt Defaultwerte der Konfiguration.
	 */
	function __construct()
	{
		global $_NL;
		
		//init pop3 class
		include_once $_NL['basedir'] . 'inc/class.NlPop3.php';
		$this->pop3 = new NlPop3();
		
		//default config
		$this->cfg['hostname'] = '';
		$this->cfg['port'] = 110;
		$this->cfg['username'] = '';
		$this->cfg['password'] = '';
		$this->cfg['using_tls'] = FALSE;
		$this->cfg['using_apop'] = FALSE;
		$this->cfg['delete_only_bounces'] = FALSE;
		$this->cfg['debug'] = FALSE;	
	}
	
	/**
	 * Erlaubt das Setzen von Konfigruationeparametern. Gibt TRUE bei Erfolg
	 * zurck, tritt ein Fehler auf, wird FALSE zurckgegeben.
	 * 
	 * @param arr $cfg [hostname, port, username, password, using_tls, using_apop, debug]
	 * hostname - (str) Hostname, z.B. meine-domain.de,
	 * port - (int) Portname, Standardmssig 110,
	 * username - (str) Benutzername,
	 * password - (str) Passwort,
	 * using_tls - (bool) TLS Verschlsselung benutzen, standardmssig FALSE
	 * using_apop - (bool) Apop Verschlsselung benutzen, standardmssig FALSE
	 * delete_only_bounces - (bool) Nur Bouncemails werden aus dem Postfach gelscht, ansonsten werden alle Emails gelscht, standardmssig FALSE (alle Mails lschen)
	 * debug - (bool)  Debugmeldungen ausgeben, standardmssig FALSE
	 * 
	 * @
	 * @return bool
	 */
	function setCfg($cfg)
	{
		if (! is_array($cfg))
		{
			return FALSE;
		}
		
		foreach ($cfg AS $k=>$v)
		{
			if (array_key_exists($k, $this->cfg))
			{
				$this->cfg[$k] = $v;
			}
		}
		
		return TRUE;
	}
	
	
	/** 
	 * Gibt einen Array mit allen Emailadressen der Bounces zurck. Gleicheitig
	 * wird das pop3 Postfach geleert. Im Fehlerfall wird FALSE zurckgegeben.
	 * 
	 * @return arr|bool
	 */
	function getAndDelete()
	{
		if (! $this->_getMails() )
		{
			return FALSE;
		}
		
		$this->_checkBounces();
		$this->_deleteMails();
		$this->_close();
		
		//filter doubletts
		$this->bouncemails = array_filter(array_unique($this->bouncemails));
		//simple email check
		$out = array();
		foreach ($this->bouncemails AS $v)
		{
		  if (strstr($v, '@') !== FALSE)
		  {
		      array_push($out, $v);
		  }
		}
		
		//print_r($this->bouncemails);
		
		return $out;
	}
	
	
	/**
	 * Gibt einen Array mit allen Bouncemails zurck. Im Fehlerfall wird
	 * FALSE zurckgegeben.
	 * 
	 * @return arr|bool
	 */
	function getBounceadresses()
	{
		if (! $this->_getMails() )
		{
			return FALSE;
		}
		
		$this->_checkBounces();
		$this->_close();
		
		//filter doubletts
		$this->bouncemails = array_filter(array_unique($this->bouncemails));
		//simple email check
		$out = array();
		foreach ($this->bouncemails AS $v)
		{
		  if (strstr($v, '@') !== FALSE)
		  {
		      array_push($out, $v);
		  }
		}
		
		//print_r($this->bouncemails);
		
		return $out;
	}
	
	
	/**
	 * Ist ein Fehler aufgetreten, wird die Fehlermeldung zurckgegeben. Ist kein Fehler vorhanden wird
	 * bool FALSE bergeben
	 * 
	 * @return str|bool
	 */
	function getError()
	{
		if (strlen($this->prv['msg_error']) > 0)
		{
			return $this->prv['msg_error'];
		}
		
		return FALSE;
	}
	
	
	/**
	 * ffnet Pop3 Connection, holt Emails ab und bereitet sie im
	 * Array $this->msgs auf. Gibt TRUE bei erfolg zurck, FALSE bewi einem 
	 * Fehler.
	 * 
	 * @return bool 
	 */
	function _getMails()
	{
		//POP 3 server host name
		$this->pop3->hostname = $this->cfg['hostname'];
		//POP 3 server host port, usually 110 but some servers use other ports Gmail uses 995 
		$this->pop3->port = $this->cfg['port'];
		//Establish secure connections using TLS
		$pop3->tls= $this->cfg['using_tls'];
		//Authentication realm or domain
		$this->pop3->realm="";
		//Workstation for NTLM authentication
		$this->pop3->workstation="";
		//SASL authentication mechanism - NEED SPECIAL CLASS
		$this->pop3->authentication_mechanism="USER";
		//Output debug information
		$this->pop3->debug= (int) $this->cfg['debug'];
		//Debug information is in HTML
		$this->pop3->html_debug= (int) $this->cfg['debug'];
		//Concatenate headers split in multiple lines
		$this->pop3->join_continuation_header_lines=1;
		
		//Connect to pop3 server
		if ($this->_setError( $this->pop3->Open() ))
		{
			return FALSE;
		}
		
		//Login
		if ($this->_setError( $this->pop3->Login($this->cfg['username'], $this->cfg['password'], (int) $this->cfg['using_apop']) ) )
		{
			return FALSE;
		}
		
		//Get stats
		$messages = 0;
		$size = 0;
		//$message and $size given by reference
		$this->pop3->Statistics($messages,$size);
		
		//No messages found, break up
		if ($messages < 1)
		{
			return TRUE;
		}
		
		//get message sizes
		$result = $this->pop3->ListMessages("",0);
		foreach ($result as $k=>$v)
		{
			$this->msgs[$k] = $this->msg;
			$this->msgs[$k]['index'] = $k;
			$this->msgs[$k]['bytesize'] = $v;
		}
		
		//get message uids
		$result = $this->pop3->ListMessages("",1);
		foreach ($result as $k=>$v)
		{
			$this->msgs[$k]['uid'] = $v;
		}
		
		//get message headers and bodys
		foreach ($this->msgs as $k=>$v)
		{
			$headers = array();
			$body = array();
			if (! $this->_setError( $this->pop3->RetrieveMessage($k, $headers, $body, -1) ) )
			{
				$this->msgs[$k]['arr_headers'] = $headers;
				$this->msgs[$k]['arr_body'] = $body;
				
				$this->msgs[$k]['txt_body'] = implode("\n", $body);
				
				foreach ($headers AS $hv)
				{
					$hv_lower = strtolower($hv);
					if (substr($hv_lower, 0, 9) == 'subject: ')
					{
						$this->msgs[$k]['subject'] = trim(substr($hv, 9));
					}
					else if (substr($hv_lower, 0, 6) == 'from: ') 
					{
						$this->msgs[$k]['from'] = trim(substr($hv, 6));
						$this->msgs[$k]['from_name'] = preg_replace('#<?[ ]*'.$this->prv['regex_email'].'[ ]*>?#', '', $this->msgs[$k]['from']);
						$hits = array();
						preg_match('#'.$this->prv['regex_email'].'#', $this->msgs[$k]['from'], $hits);
						if (array_key_exists('0', $hits))
						{
							$this->msgs[$k]['from_email'] = $hits['0'];
						} 
					}
					else if (substr($hv_lower, 0, 4) == 'to: ') 
					{
						$this->msgs[$k]['to'] = trim(substr($hv, 4));
						$this->msgs[$k]['to_name'] = preg_replace('#<?[ ]*'.$this->prv['regex_email'].'[ ]*>?#', '', $this->msgs[$k]['to']);
						$hits = array();
						preg_match('#'.$this->prv['regex_email'].'#', $this->msgs[$k]['to'], $hits);
						if (array_key_exists('0', $hits))
						{
							$this->msgs[$k]['to_email'] = $hits['0'];
						} 
					}
		
				}
			}
		}
		
		$this->pop3->ResetDeletedMessages();
			
		// echo '<pre>';
		// print_r($this->msgs);
		// echo '</pre>';
		
		return TRUE;
	}
	
	/**
	 * Routine zum checken nach Bouncemails
	 */
	function _checkBounces()
	{
		foreach ($this->msgs as $k=>$v)
		{
			$mail = '';
			
			//blacklist
            //check by header
			$is_multi_bounce = FALSE;
			foreach ($v['arr_headers'] AS $hv)
			{
				if (strtolower(substr($hv, 0, 21)) == "x-failed-recipients: " || $is_multi_bounce)
				{
					$this->msgs[$k]['is_bounce'] = TRUE;
					
					//extract email adress
					if ($is_multi_bounce)
					{
					   $mail = trim($hv);
					}
					else
					{
					   $mail = trim(substr($hv, 21));
					}
					
					//simple email check
					//break up, if ':' is found (in new header key) or '@' ist not found (no email adress)
					if ( (stristr($mail, ':') !== FALSE) || (stristr($mail, '@') === FALSE) )
					{
					   break;
					}
                    
                    //check mutiple bounce
					if (substr($mail, -1, 1) == ',')
					{
                        $mail = substr($mail, 0, (strlen($mail)-1) );
					    array_push($this->bouncemails, $mail);
					    $is_multi_bounce = TRUE;
					    continue;
					}
					//single bounce
					else
					{
					    //check for mutiple bounce mails in one row
					    $mails = explode(',', $mail);
                        foreach ($mails AS $single)
                        {
                            array_push($this->bouncemails, trim($single));
                        }
					   break;
					}
				}
			}
			
			//whitelist
			//check by subject
            $subject = strtolower($v['subject']);
            foreach ($this->whitelist_subject AS $single)
            {
                if (strstr($subject, $single) !== FALSE)
                {
                    $this->msgs[$k]['is_bounce'] = TRUE;
                }
            }
            
            
            //whitelist
			//check by body
            $body = strtolower($v['txt_body']);
            foreach ($this->whitelist_body AS $single)
            {
                if (strstr($body, $single) !== FALSE)
                {
                    $this->msgs[$k]['is_bounce'] = TRUE;
                }
            }
            
			
			//blacklist
            //check by body 
			foreach ($v['arr_body'] AS $bv)
			{
				if (strtolower(substr($bv, 0, 4)) == "to: ")

				{
					$mail = trim(substr($bv, 4));
					if (preg_match('#'.$this->prv['regex_email'].'#', $bv, $hits) )
					{
						$this->msgs[$k]['is_bounce'] = TRUE;
						$mail = $hits['0'];
					}
				}
			}
			
			if ($mail != '')
			{
				array_push($this->bouncemails, $mail);
				continue;
			}
			
			//blacklist
			//check by preg_match
			if (preg_match('#(<)('.$this->prv['regex_email'].')(>?)#', $v['txt_body'], $hits) )
			{
				$this->msgs[$k]['is_bounce'] = TRUE;
				$mail = $hits['2'];
			}
			
			if ($mail != '')
			{
				array_push($this->bouncemails, $mail);
				continue;
			}
		}
	}


	/**
	 * Setzt fr alle Emails Flag zum lschen.
	 */
	function _deleteMails()
	{
	
		foreach ($this->msgs AS $k=>$v)
		{
			if ($this->cfg['delete_only_bounces'])
			{
				if ($v['is_bounce'])
				{
				
					$this->pop3->DeleteMessage($k);
				}
			}
			else
			{
				$this->pop3->DeleteMessage($k);
			}
		}
	}
	
	
	/**
	 * Schliet pop3 Connection. Emails die zum lschen makiert wurden, 
	 * werden dabei gelscht.
	 */
	function _close()
	{
		$this->pop3->Close();
	}	
	
	/**
	 * Setzt Fehler, wenn ein String mit der Lnge > 0 bergeben wird. Wird der 
	 * Fehler gesetzt, wird true zurckgegeben, andernfalls false
	 * 
	 * @param str $msg
	 * @return bool
	 */
	function _setError($msg)
	{
		if (strlen($msg) > 0)
		{
			$this->prv['msg_error'] = $msg;	
			
			if ($this->cfg['debug'])
			{
				echo $this->prv['msg_error'];
			}
			return TRUE;
		}
		
		return FALSE;
	}
} 

?>
