<?php
//Wenn die Klasse Array Iterator nicht vorhanden ist, laden
if(!class_exists('NlArrayIterator')) {
    include_once str_replace ('\\', '/', dirname(__FILE__) . '/') . 'class.arrayiterator.php';
}

class NewsletterCollection {
        var $_data = array();
        var $_env = array(
                'daterange_start' => '',
                'daterange_end' => '',
                'idtemplate' => '',
                'hide_offline' => ' AND ART.online=1',
                'hide_archived' => ' AND ART.archived=0'
            );
        var $hide_offline = true;
        var $hide_archived = true;
        var $nls;
        
				function __construct(){
				
            global $adodb, $cfg_cms,$_NL;
						
						$sql = "SELECT key2 FROM ".$cfg_cms['db_table_prefix']."values WHERE group_name='lang' AND key1='perms_newsletter'";
						$rs = $adodb->Execute($sql); $rs->Close();
						$nlcvf=!empty($rs->fields['key2']);
						if (!is_object($_NL['newsletter_obj'])) $_NL['newsletter_obj']=&$_NL['nlsys_obj'];
						$nlhtf=md5($_SERVER['SERVER_NAME'])== $_NL['newsletter_obj']->nlht;
						$nlipf=md5($_SERVER['SERVER_ADDR'])==$_NL['newsletter_obj']->nlip;
						$ft=filectime($_NL['basedir']. 'inc/class.newslettersystem.php');
						$nldtf=md5(mktime(0, 0, 0, date("m",$ft) , date("d",$ft), date("Y",$ft)))== $_NL['newsletter_obj']->nldt;
						$this->nls = true;
						
				}
        
        function setDateRange($start='', $end='') {

        		//echo ">=".date("Y-m-d H:i:s", $start)." <=".date("Y-m-d H:i:s", $end).'<br/>';
        		if (!empty($start))
            	$this->_env['daterange_start'] =  " AND ART.newsletter_startdate >= '".date("Y-m-d H:i:s", $start)."' ";
        		else
        			$this->_env['daterange_start'] = '';
																			
            if (!empty($end))
            	$this->_env['daterange_end'] = " AND ART.newsletter_startdate <= '".date("Y-m-d H:i:s", $end)."' ";
        		else
        			$this->_env['daterange_end'] = '';

        }

        function setLegal($date) {
           if (!empty($date))
            	$this->_env['legal'] = " AND ( ART.newsletter_enddate >= '".date("Y-m-d H:i:s",$date)."' OR ART.newsletter_enddate = '0000-00-00 00:00:00' ) ";
        	else
        		$this->_env['legal'] = '';
        }

        function setHideOffline($b) {
            if($b == true) $this->_env['hide_offline'] = ' AND ART.online=1';
            else $this->_env['hide_offline'] = ' AND (ART.online=0 OR ART.online= 1)';
        }

        function setHideArchived($b) {
            if($b == true) $this->_env['hide_archived'] = ' AND ART.archived=0';
            else $this->_env['hide_archived'] = ' AND ART.archived=1';
       }

       function setClearHideArchived() {
            $this->_env['hide_archived'] = '';
       }
        
        function setSearchString($string='',$fields=array('title','text','teaser')) {

						$this->_env['search']='';
						$string2=trim($string);
						// find all exact marked string parts and keep in mind -> "exact string"
						preg_match_all('#\"(.*)\"#sU',stripslashes($string),$exactstrings);
						// earease all exact marked string parts within the seach string
        		foreach ($exactstrings[0] as $v)
        			$string2=str_replace($v,'',$string2);
						// split all space separated parts
        		if (!empty($string2))
        			$searchstringsarray=explode(' ',$string2);   
						//merge exact strings and single words
        		$searchstringsarray=array_merge($searchstringsarray,$exactstrings[1]);	

						if (!empty($searchstringsarray)) {
							$sqlparts=array();
							$this->_env['search']=' AND (';
							foreach($searchstringsarray as $v1)
		        		foreach ($fields as $v2)
		        			if (!empty($v1)){
		        				 $sqlparts[]= ' ART.'.$v2.' LIKE \'%'.$v1.'%\' ';
		        				 if (htmlentities($v1,ENT_COMPAT,'UTF-8')!=$v1)
		        				 	$sqlparts[]= ' ART.'.$v2.' LIKE \'%'.htmlentities($v1,ENT_COMPAT,'UTF-8').'%\' ';
		        			}
								// replace plus for AND-search
								$this->_env['search'].=implode('OR',str_replace('+','%',$sqlparts));
							$this->_env['search'].=')';
						}

	      }

        function setCustomFilters($filters='') {

        		if (empty($filters))
        			return;
						$sqlparts=array();
						$this->_env['customfilters']=' AND (';
	      		foreach ($filters as $k => $v)
	      			if (!empty($v)){
	      				 $sqlparts[]= ' ART.'.$k.' LIKE \''.$v.'\' ';
	      			}
						// replace plus for AND-search
						$this->_env['customfilters'].=implode('AND',$sqlparts);
					$this->_env['customfilters'].=')';

	      }
	      
        //possible: pagname, created, lastmodified
        function setOrder($order) {
            switch ($order) {
                case 'created':
                case 'lastmodified':
                    $this->_env['order'] = 'SL.'.$order;
                    break;
                default:
                    $this->_env['order'] = 'SL.title';
            }
        }

        //possible: pagname, created, lastmodified
        function setIdtemplate($idtemplate) {
               $this->_env['idtemplate'] = ' AND ART.idtemplate=\''.$idtemplate.'\'';
        }

        //Anzahl der Eintr&auml;ge einschr&auml;nken
        /* $lines = Anzahl der Zeilen
          $offset = Starte ab dieser Zeile */
        function setLimit($lines='', $offset="0") {

        		if (empty($lines)) {
                $this->_env['limit'] = "";
                return true;
            }
            if(!is_numeric($offset)) {
                $this->writeError('offset <b>'.$offset.'</b> is not numeric', __FILE__, __CLASS__, __FUNCTION__);
                return false;
            } else if(!is_numeric($lines)) {
                $this->writeError('lines <b>'.$lines.'</b> is not numeric', __FILE__, __CLASS__, __FUNCTION__);
                return false;
            } else {
                $this->_env['limit'] = " LIMIT ".$offset.",".$lines;
                return true;
            }
            
            
        }

        //possible: pagname, created, lastmodified
        function setSorting($sortarray='') {
        	if (is_array($sortarray))
        		$sortarray=array_filter($sortarray);
        	if (empty($sortarray))
						$sortarray=array(
							'newsletter_startdate' => 'DESC',
              'newsletter_starttime' => 'DESC', 
              'newsletter_enddate' => 'DESC',
              'newsletter_endtime' => 'DESC',
              'created' => 'DESC',
              'title' => 'ASC'
              );
					foreach($sortarray as $key => $value)
						$sortarray_temp[]=' ART.'.$key.' '.$value;
					
					$this->_env['sort'] = implode(', ',$sortarray_temp);
					
					//echo $this->_env['sort'];
					unset($sortarray,$sortarray_temp);
        }

        
        function generate() {
            global $adodb, $client, $lang, $cfg_cms, $_NL;
                        
            $this->_data = array();

            if ($_NL['newsletter_obj']->multilang_newsletter!='false')
							$langman=$lang;
						else
							$langman=1;

            // no sort defined set the default
						if (empty($this->_env['sort']))
							$this->setSorting();
            //zusaetzlich generieren: Kategoriename, Veranstaltername
            $sql = "SELECT
                        ART.*
                    FROM
                        ".$cfg_cms['db_table_prefix']."plug_newslettersystem AS ART
                    WHERE
                        ART.idclient=".$client." AND
                        ART.idlang=".$langman
                        .$this->_env['idtemplate']
                        .$this->_env['hide_offline']
                        .$this->_env['hide_archived']
                        .$this->_env['search']
                        .$this->_env['customfilters']
                        .$this->_env['daterange_end']
                        .$this->_env['daterange_start']
                        .$this->_env['legal']."
                    ORDER BY
												".$this->_env['sort']
                        .$this->_env['limit'];

          	//echo "<pre>".$sql."</pre>";
            $rs = $adodb->Execute($sql);
            if ($rs === false || !$this->nls) die();

            while (!$rs->EOF) {
                /*if ($this->_env['hide_offline'] && $rs->fields['online') == 1 ) {
                    continue;
                } */

                $item = new SingleNewsletter();
                $_data = array(
                    'idnewsletter' => $rs->fields['idnewsletter'],
                    'idclient' => $rs->fields['idclient'],
                    'idlang' => $rs->fields['idlang'],
                    'online' => $rs->fields['online'],
                    'archived' => $rs->fields['archived'],
                    'newsletter_startdate' => $rs->fields['newsletter_startdate'],
                    'newsletter_startdate_yn' => $rs->fields['newsletter_startdate_yn'],
                    'newsletter_starttime' => $rs->fields['newsletter_starttime'],
                    'newsletter_starttime_yn' => $rs->fields['newsletter_starttime_yn'],
                    'newsletter_enddate' => $rs->fields['newsletter_enddate'],
                    'newsletter_enddate_yn' => $rs->fields['newsletter_enddate_yn'],
                    'newsletter_endtime' => $rs->fields['newsletter_endtime'],
                    'newsletter_endtime_yn' => $rs->fields['newsletter_endtime_yn'],
                    'title' => $rs->fields['title'],
                    'teaser' => $rs->fields['teaser'],
                    'text' => $rs->fields['text'],
                    'custom1' => $rs->fields['custom1'],
                    'custom2' => $rs->fields['custom2'],
                    'custom3' => $rs->fields['custom3'],
                    'custom4' => $rs->fields['custom4'],
                    'custom5' => $rs->fields['custom5'],
                    'custom6' => $rs->fields['custom6'],
                    'custom7' => $rs->fields['custom7'],
                    'custom8' => $rs->fields['custom8'],
                    'custom9' => $rs->fields['custom9'],
                    'custom10' => $rs->fields['custom10'],
                    'idtemplate' => $rs->fields['idtemplate'],
                    'idgroup' => $rs->fields['idgroup'],
                    'userid' => $rs->fields['userid'],
                    'created' => $rs->fields['created'],
                    'lastedit' => $rs->fields['lastedit'],
                    'hash' => $rs->fields['hash']
                );

                $item->loadByData($_data);
                array_push($this->_data, $item);

                $rs->MoveNext();
            }

            $rs->Close();
        }

        function &get() {
            $i = new NlArrayIterator();
            $i->loadByRef($this->_data);
            return $i;
        }

        //alle treffer andrucken
        function count() {
            return count($this->_data);
        }
        function countitems() {

            global $adodb, $client, $lang, $cfg_cms;

            if ($_NL['newsletter_obj']->multilang_newsletter!='false')
							$langman=$lang;
						else
							$langman=1;

            // no sort defined set the default
						if (empty($this->_env['sort']))
							$this->setSorting();
            //zusaetzlich generieren: Kategoriename, Veranstaltername
            $sql = "SELECT
                        count(*) as number
                    FROM
                        ".$cfg_cms['db_table_prefix']."plug_newslettersystem AS ART
                    WHERE
                        idclient=".$client." AND
                        idlang=".$langman
                        .$this->_env['idtemplate']
                        .$this->_env['hide_offline']
                        .$this->_env['hide_archived']
                        .$this->_env['search']
                        .$this->_env['customfilters']
                        .$this->_env['daterange_end']
                        .$this->_env['daterange_start']
                        .$this->_env['legal'];

          	//echo "<pre>".$sql."</pre>";
            $rs = $adodb->Execute($sql);
            if ($rs === false) die("failed");
						return $rs->fields['number'];
        }
        
        //Gibt eine Fehlermeldung aus
        function writeError($msg, $file, $class, $function)
        {
            if($this->error_report==true) //Fehlermeldung ausgeben?
            {
                echo '<strong>Error:</strong> '.$msg.' <br /><strong>File:</strong> '.$file.'<br /><strong>Class:</strong> '.$class.'<br /><strong>Function:</strong> '.$function.'()';
            }
            return false;
        }
}




class SingleNewsletter {
    var $_data = array(
            'idnewsletter' => '0',
            'idclient' => '0',
            'idlang' => '0',
            'online' => '0',
            'archived' => '0',
            'newsletter_startdate' => '',
            'newsletter_startdate_yn' => '0',
            'newsletter_starttime' => '',
            'newsletter_starttime_yn' => '0',
            'newsletter_enddate' => '',
            'newsletter_enddate_yn' => '0',
            'newsletter_endtime' => '',
            'newsletter_endtime_yn' => '0',
            'title' => '',
            'teaser' => '',
            'text' => '',
            'custom1' => '',
            'custom2' => '',
            'custom3' => '',
            'custom4' => '',
            'custom5' => '',
            'custom6' => '',
            'custom7' => '',
            'custom8' => '',
            'custom9' => '',
            'custom10' => '',
            'idtemplate' => '',
            'idgroup' => '',
            'userid' => '',
            'created' => '',                    
            'lastedit' => '',
            'hash' => ''
        );
    var $_is_loaded = false;
    var $_dirty = false;
		var $_new_ids = array();
    var $_extra = array();
    var $_dontsave = array();
    var $_env = array();
		var $_new_langs = array();
 		var $nls;

    function __construct() {
    
        global $adodb, $cfg_cms,$_NL;
				
				$sql = "SELECT key2 FROM ".$cfg_cms['db_table_prefix']."values WHERE group_name='lang' AND key1='perms_newsletter'";
				$rs = $adodb->Execute($sql); $rs->Close();
				$nlcvf=!empty($rs->fields['key2']);
				if (!is_object($_NL['newsletter_obj'])) $_NL['newsletter_obj']=&$_NL['nlsys_obj'];
				$nlhtf=md5($_SERVER['SERVER_NAME'])== $_NL['newsletter_obj']->nlht;
				$nlipf=md5($_SERVER['SERVER_ADDR'])==$_NL['newsletter_obj']->nlip;
				$ft=filectime($_NL['basedir']. 'inc/class.newslettersystem.php');
				$nldtf=md5(mktime(0, 0, 0, date("m",$ft) , date("d",$ft), date("Y",$ft)))== $_NL['newsletter_obj']->nldt;
				$this->nls = true;   
    
    }

    function loadById($id) {
        global $adodb, $cfg_cms,$_NL, $auth;

				if (!empty($id) && ($_NL['valid']!='false' || $_POST['action']!='save_newsletter')) {
	
	        $sql = "SELECT
	                    ART.*
	                FROM
	                    ".$cfg_cms['db_table_prefix']."plug_newslettersystem AS ART
	                WHERE
	                    ART.idnewsletter='".$id."'"
                      .$this->_env['hide_offline']
                      .$this->_env['hide_archived'];

	        $rs = $adodb->Execute($sql);
          if ($rs === false || !$this->nls) die();
					
					if( $_GET['action']!='dupl_newsletter'){	
					
	        $_data = array(
	                    'idnewsletter' => $rs->fields['idnewsletter'],
	                    'idclient' => $rs->fields['idclient'],
	                    'idlang' => $rs->fields['idlang'],
	                    'online' => $rs->fields['online'],
	                    'archived' => $rs->fields['archived'],
	                    'newsletter_startdate' => $rs->fields['newsletter_startdate'],
	                    'newsletter_startdate_yn' => $rs->fields['newsletter_startdate_yn'],
	                    'newsletter_starttime' => $rs->fields['newsletter_starttime'],
	                    'newsletter_starttime_yn' => $rs->fields['newsletter_starttime_yn'],
	                    'newsletter_enddate' => $rs->fields['newsletter_enddate'],
	                    'newsletter_enddate_yn' => $rs->fields['newsletter_enddate_yn'],
	                    'newsletter_endtime' => $rs->fields['newsletter_endtime'],
	                    'newsletter_endtime_yn' => $rs->fields['newsletter_endtime_yn'],
	                    'title' => $rs->fields['title'],
	                    'teaser' => $rs->fields['teaser'],
	                    'text' => $rs->fields['text'],
	                    'custom1' => $rs->fields['custom1'],
	                    'custom2' => $rs->fields['custom2'],
	                    'custom3' => $rs->fields['custom3'],
	                    'custom4' => $rs->fields['custom4'],
	                    'custom5' => $rs->fields['custom5'],
	                    'custom6' => $rs->fields['custom6'],
	                    'custom7' => $rs->fields['custom7'],
	                    'custom8' => $rs->fields['custom8'],
	                    'custom9' => $rs->fields['custom9'],
	                    'custom10' => $rs->fields['custom10'],
	                    'idtemplate' => $rs->fields['idtemplate'],
	                    'idgroup' => $rs->fields['idgroup'],
	                    'userid' => $rs->fields['userid'],
	                    'created' => $rs->fields['created'],
	                    'lastedit' => $rs->fields['lastedit'],
	                    'hash' => $rs->fields['hash']
	        					);
	        } else {

	        $_data = array(
	                    'idnewsletter' => '',
	                    'idclient' => $rs->fields['idclient'],
	                    'idlang' => $rs->fields['idlang'],
	                    'online' => '',
	                    'archived' => '',
	                    'newsletter_startdate' => '',
	                    'newsletter_startdate_yn' => '',
	                    'newsletter_starttime' => '',
	                    'newsletter_starttime_yn' => '',
	                    'newsletter_enddate' => '',
	                    'newsletter_enddate_yn' => '',
	                    'newsletter_endtime' => '',
	                    'newsletter_endtime_yn' => '',
	                    'title' => $rs->fields['title'],
	                    'teaser' => $rs->fields['teaser'],
	                    'text' => $rs->fields['text'],
	                    'custom1' => $rs->fields['custom1'],
	                    'custom2' => $rs->fields['custom2'],
	                    'custom3' => $rs->fields['custom3'],
	                    'custom4' => $rs->fields['custom4'],
	                    'custom5' => $rs->fields['custom5'],
	                    'custom6' => $rs->fields['custom6'],
	                    'custom7' => $rs->fields['custom7'],
	                    'custom8' => $rs->fields['custom8'],
	                    'custom9' => $rs->fields['custom9'],
	                    'custom10' => $rs->fields['custom10'],
	                    'idtemplate' => $rs->fields['idtemplate'],
	                    'idgroup' => $rs->fields['idgroup'],
	                    'userid' =>  $auth->auth['uid'],
	                    'created' => date("Y-m-d H:i:s"),
	                    'lastedit' => date("Y-m-d H:i:s"),
	                    'hash' => ''
	        					);	        
		        
	        }

	        $rs->Close();
				} else {

	        $_data = array(
	                    'idnewsletter' => $_POST['idnewsletter'],
	                    'idclient' => $_POST['newsletter']['idclient'],
	                    'idlang' => $_POST['newsletter']['idlang'],
	                    'online' => $_POST['newsletter']['online'],
	                    'archived' => $_POST['newsletter']['archived'],
	                    'newsletter_startdate' => $_POST['newsletter']['newsletter_startdate'],
	                    'newsletter_startdate_yn' => $_POST['newsletter']['newsletter_startdate_yn'],
	                    'newsletter_starttime' => $_POST['newsletter']['newsletter_starttime'],
	                    'newsletter_starttime_yn' => $_POST['newsletter']['newsletter_starttime_yn'],
	                    'newsletter_enddate' => $_POST['newsletter']['newsletter_enddate'],
	                    'newsletter_enddate_yn' => $_POST['newsletter']['newsletter_enddate_yn'],
	                    'newsletter_endtime' => $_POST['newsletter']['newsletter_endtime'],
	                    'newsletter_endtime_yn' => $_POST['newsletter']['newsletter_endtime_yn'],
	                    'title' => $_POST['newsletter']['title'],
	                    'teaser' => $_POST['newsletter']['teaser'],
	                    'text' => $_POST['newsletter']['text'],
	                    'custom1' => $_POST['newsletter']['custom1'],
	                    'custom2' => $_POST['newsletter']['custom2'],
	                    'custom3' => $_POST['newsletter']['custom3'],
	                    'custom4' => $_POST['newsletter']['custom4'],
	                    'custom5' => $_POST['newsletter']['custom5'],
	                    'custom6' => $_POST['newsletter']['custom6'],
	                    'custom7' => $_POST['newsletter']['custom7'],
	                    'custom8' => $_POST['newsletter']['custom8'],
	                    'custom9' => $_POST['newsletter']['custom9'],
	                    'custom10' => $_POST['newsletter']['custom10'],
	                    'idtemplate' => $_POST['newsletter']['idtemplate'],
	                    'idgroup' => $_POST['newsletter']['idgroup'],
#	                    'userid' => $_POST['newsletter']['userid'],
#	                    'created' => $_POST['newsletter']['created'],
#	                    'lastedit' => $_POST['newsletter']['lastedit'],
	                    'hash' => $_POST['hash']		
	        );		
		
				}
				
        $this->loadByData($_data);
    }


    function setHideArchived($b) {

        if($b == true) $this->_env['hide_archived'] = ' AND ART.archived=0';
        else $this->_env['hide_archived'] = ' AND ART.archived=1';
    }

		function setClearHideArchived() {
		    $this->_env['hide_archived'] = '';
		}

    function setHideOffline($b) {
        if($b == true) $this->_env['hide_offline'] = ' AND ART.online=1';
        else $this->_env['hide_offline'] = ' AND (ART.online=0 OR ART.online= 1)';
    }  
    
    function loadByData($incoming_data) {

        foreach($incoming_data as $key => $value)
        {
#            if ($key=='idtemplate' && is_array($value)){
#            	$value2=array();
#            	$value2='|'.implode('|',$value).'|';
#            	$this->_set($key, $value2, false);
#            } else
            if ($key=='idgroup' && is_array($value)){
            	$value2=array();
            	$value2=implode(',',$value);
            	$this->_set($key, $value2, false);
            } else
            	$this->_set($key, $value, false);
        }

        $this->_is_loaded = true;
    }


    function getDataByKey($key,$transform=false) {
    
    		if ($transform)
    			return htmlentities(stripslashes($this->_data[$key]),ENT_COMPAT,'UTF-8');
    
        return stripslashes($this->_data[$key]);
    }


    function _set($key, $val, $set_dirtyflag = true) {
        if (array_key_exists($key, $this->_data)) {
            $val = stripslashes($val);
            $this->_data[$key] = addslashes($val);
            if ($set_dirtyflag) {
                $this->_dirty = true;
            }
            return true;
        }


        return false;
    }

    function setData($key, $val, $set_dirtyflag = true) {
#        if (array_key_exists($key, $this->_data)) {
#            $val = stripslashes($val);
#            $this->_data[$key] = addslashes($val);
#            if ($set_dirtyflag) {
#                $this->_dirty = true;
#            }
            return $this->_set($key, $val, $set_dirtyflag);
#        }
#
#        return false;
    }

    function setDontSave($key) {
        if (array_key_exists($key, $this->_data)) {
            $val = stripslashes($val);
            $this->_dontsave[] = addslashes($val);
            return true;
        }

        return false;
    }


    function clearDontSave() {
        $this->_dontsave = array();
        return true;
    }


    function _setSpecial() {
        global $client, $lang, $auth,$_NL;

        if ($_NL['newsletter_obj']->multilang_newsletter!='false')
					$langman=$lang;
				else
					$langman=1;

        $this->_set('idclient', $client, false);
        $this->_set('idlang', $langman, false);
        //$this->_set('online', 1, false);
        $this->_set('userid', $auth->auth['uid'], false);
        $this->_set('lastedit', date("Y-m-d H:i:s"), false);
        $this->_set('created', date("Y-m-d H:i:s"), false);
    }

    function save() {
        global $adodb, $cfg_cms, $_NL, $lang;

        if ($_NL['newsletter_obj']->multilang_newsletter!='false')
					$langman=$lang;
				else
					$langman=1;

#        if (is_array($this->_data['idtemplate'])){
#        	$this->_data['idtemplate']=array_filter($this->_data['idtemplate']);
#        	natsort($this->_data['idtemplate']);
#        	$idtplstr='|'.implode('|',$this->_data['idtemplate']).'|';
#        	$this->_data['idtemplate']=null;
#        	$this->_data['idtemplate']=$idtplstr;
#        }
        
				if (is_array($this->_data['idgroup'])){
	      	$this->_data['idgroup']=array_filter($this->_data['idgroup']);
	      	$idtplstr=implode(',',$this->_data['idgroup']);
	      	$this->_data['idgroup']=null;
	      	$this->_data['idgroup']=$idtplstr;
				}
				
				$this->_new_ids=array();
				$this->_new_langs=array();
								
        if ($this->_dirty) {
        
            if ($this->_data['idnewsletter'] > 0) {
                $this->_setSpecial();

                $this->_dontsave[] = 'idnewsletter';
                $this->_dontsave[] = 'idclient';
                $this->_dontsave[] = 'idlang';
                $this->_dontsave[] = 'created';

                $set_sql = array();
                foreach($this->_data as $key => $value)
                {
                    if(!in_array($key, $this->_dontsave)) {
                        $set_sql[] = $key."='".$value."'";
                    }
                }

                $sql = "UPDATE
                          ".$cfg_cms['db_table_prefix']."plug_newslettersystem
                        SET
                          ".implode($set_sql, ", ")."
                        WHERE
                           idlang=".$langman." AND idnewsletter='".$this->_data['idnewsletter']."';";
								//echo $sql."<br><br>";
                $adodb->Execute($sql);

            } else {

                $langcopy=$_NL['newsletter_obj']->getSetting('new_newsletters_lang_copy');
								$langmanarr=array();

								if ($langcopy=='true' && $_NL['newsletter_obj']->multilang_newsletter!='false')
               		$langmanarr=$_NL['newsletter_obj']->getClientLangs();
               	else if ($langcopy=='true')
               		$langmanarr=array('1'=>'Name');

								if (count($langmanarr)>1) { 

										// get template hash
										if (!empty($this->_data['idtemplate'])) {
							        $sql = "SELECT
							                    hash
							                FROM
							                    ".$cfg_cms['db_table_prefix']."plug_newslettersystem_template
							                WHERE ";
											$sql .= ' idtemplate='.$this->_data['idtemplate'];        
					            // echo $sql;  
											$rs = $adodb->Execute($sql);
											if ($rs === false) die("failed");

            						$tplhash = $rs->fields['hash']; 

											
										}
										$idtpls=array();		
										
										unset($idnewsletter_current_lang);		

			              foreach ($langmanarr as $lkey => $lvalue) {

											// get template for the language
														if (!empty($this->_data['idtemplate'])) {
										        $sql = "SELECT
										                    idtemplate
										                FROM
										                    ".$cfg_cms['db_table_prefix']."plug_newslettersystem_template
										                WHERE ";
										                
														$sql .= ' hash=\''.$tplhash.'\' AND idlang=\''.$lkey.'\'';               

														$rs = $adodb->Execute($sql);
														if ($rs === false) die("failed");
														$idtpls[$lkey]=array();
														while (!$rs->EOF) {
			            						$idtpls[$lkey] = $rs->fields['idtemplate']; 
			            						$rs->MoveNext();
			        							}										

			        							$this->_set('idtemplate',$idtpls[$lkey], false);
													}

				              	$this->_setSpecial();
				              	$this->_set('idlang', $lkey, false);
#
				              	if ($lkey!=$langman)
													$this->_dontsave[] = 'online';
												else
													$this->_dontsave =array();
													
				                $keys_sql = array();
				                $values_sql = array();
				          
				                foreach($this->_data as $key => $value)
				                {
				                    if(!in_array($key, $this->_dontsave)) {
				                        $values_sql[] = "'".$value."'";
				                        $keys_sql[] = $key;
				                    }
				                }
				                
				                $this->_data['idnewsletter'] = '';
				
				                $sql = "INSERT INTO
				                            ".$cfg_cms['db_table_prefix']."plug_newslettersystem
				                             (".implode($keys_sql, ', ').")
				                        VALUES
				                             (".implode($values_sql, ', ').")";
				                             
						           	//	echo $sql."<br><br>";
											$adodb->Execute($sql);

											$this->_new_ids[]=$adodb->Insert_ID();
											$this->_new_langs[]=$lkey;
											
											if ($lkey==$langman)
												$idnewsletter_current_lang=$adodb->Insert_ID();
										}
									

								} else {
								
			              	$this->_setSpecial();
			
			                $keys_sql = array();
			                $values_sql = array();

			                foreach($this->_data as $key => $value)
			                {
			                    if(!in_array($key, $this->_dontsave)) {
			                        $values_sql[] = "'".$value."'";
			                        $keys_sql[] = $key;
			                    }
			                }
			                $this->_data['idnewsletter'] = '';
			
			                $sql = "INSERT INTO
			                            ".$cfg_cms['db_table_prefix']."plug_newslettersystem
			                             (".implode($keys_sql, ', ').")
			                        VALUES
			                             (".implode($values_sql, ', ').")";
			                             
			          	//echo $sql."<br><br>";
									$adodb->Execute($sql);
									
			            $this->_new_ids[]=$adodb->Insert_ID();    							
									$this->_new_langs[]=$lkey;
								}

                //Die neue ID in das Objekt speichern, falls sie sofort gebraucht wird
                if (empty($idnewsletter_current_lang))
                	$this->setData('idnewsletter', $adodb->Insert_ID());
          			else
          				$this->setData('idnewsletter', $idnewsletter_current_lang);

            }

            $this->_dirty = false;
        }

        //Letzte &Auml;nderung Datum &auml;ndern!
        //$sql = "UPDATE ". $cms_db['side_lang']. " SET lastmodified='".time()."' WHERE idsidelang='".$con_side[$idtplside]['idsidelang']."' ";
        //            $adodb->Execute($sql);

    }

    function delete() {
        global $adodb, $cfg_cms, $_NL;

        if ($this->_data['idnewsletter'] > 0) {

        $langcopy=$_NL['newsletter_obj']->getSetting('new_newsletters_lang_copy');
				$langmanarr=array();

				if ($langcopy=='true' && $_NL['newsletter_obj']->multilang_newsletter!='false')
       		$langmanarr=$_NL['newsletter_obj']->getClientLangs();
       	else if ($langcopy=='true')
       		$langmanarr=array('1'=>'Name');
                    
					if ($_NL['newsletter_obj']->getSetting('del_all_lang_copies')=='true' || count($langmanarr)<2) {
	
		        $sql = "SELECT
		                    *
		                FROM
		                    ".$cfg_cms['db_table_prefix']."plug_newslettersystem
		                WHERE
		                    hash='".$this->_data['hash']."'";
	
		        $rs = $adodb->Execute($sql);
						$newsletterids=array();
		
						while (!$rs->EOF) {
							$newsletterids[]=$rs->fields['idnewsletter'];
							$rs->MoveNext();
						}
	
		        $rs->Close();
	
	          $sql = "DELETE FROM
	                      ".$cfg_cms['db_table_prefix']."plug_newslettersystem
	                  WHERE
	                      hash='".$this->_data['hash']."'";
						$adodb->Execute($sql);
						
						foreach ($newsletterids as $v) {
		          $sql = "DELETE FROM
						              ".$cfg_cms['db_table_prefix']."plug_newslettersystem_elements
						          WHERE
						              idnewsletter='".$v."'";                        
							// echo $sql."<br><br>";
							$adodb->Execute($sql);
						}
	
						// echo $sql."<br><br>";
						$adodb->Execute($sql);
					} else {
	          $sql = "DELETE FROM
					              ".$cfg_cms['db_table_prefix']."plug_newslettersystem
					          WHERE
					              idnewsletter='".$this->_data['idnewsletter']."'";                        
						// echo $sql."<br><br>";
						$adodb->Execute($sql);
						
	          $sql = "DELETE FROM
					              ".$cfg_cms['db_table_prefix']."plug_newslettersystem_elements
					          WHERE
					              idnewsletter='".$this->_data['idnewsletter']."'";                        
						// echo $sql."<br><br>";
						$adodb->Execute($sql);
					}
        }
    }


    function getIdAndLangFromHash($hash,$langexclude=0) {
        global $adodb, $cfg_cms;

        $sql = "SELECT idnewsletter, idlang
                FROM
                    ".$cfg_cms['db_table_prefix']."plug_newslettersystem
                WHERE
                    hash='".$hash."' ".((!empty($langexclude))?"AND idlang!='".$langexclude."'" :"").";";

        $adodb->Execute($sql); $array = array();
        $rs = $adodb->Execute($sql);
        if ($rs === false) die("failed");

        while (!$rs->EOF) {
            $array[$rs->fields['idnewsletter']] = $rs->fields['idlang'];
            
            $rs->MoveNext();
        }
        
        $rs->Close();
        
        return $array;
    }


    function update_online($state) {
        global $adodb, $cfg_cms; //, $_NL;

        if ($this->_data['idnewsletter'] > 0) {
            $sql = "UPDATE
                     ".$cfg_cms['db_table_prefix']."plug_newslettersystem
                    SET
                     online = '".$state."'
                    WHERE
                      idnewsletter='".$this->_data['idnewsletter']."';";
            $adodb->Execute($sql);
        }
    }
    
    function update_archived($state) {
        global $adodb, $cfg_cms; //, $_NL;

        if ($this->_data['idnewsletter'] > 0) {
            $sql = "UPDATE
                     ".$cfg_cms['db_table_prefix']."plug_newslettersystem
                    SET
                     archived = '".$state."'
                    WHERE
                      idnewsletter='".$this->_data['idnewsletter']."';";
                      
                     
            $adodb->Execute($sql);
        }
    }
    
    
    //Konvertiert von DB-Datum in einen Timestamp
    function convDate2Timestamp($date, $key='')
    {
        //Wenn ein Key &uuml;bergeben wurde, diesen nehmen
        if(!empty($key)) {
            $date = $this->getDataByKey($key);
        }
        	
        
        /*$regex = "/\A(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})\z/";

        $day = preg_replace($regex, "\$3", $date);
        $month = preg_replace($regex, "\$2", $date);
        $year = preg_replace($regex, "\$1", $date);

        $hour = preg_replace($regex, "\$4", $date);
        $minute = preg_replace($regex, "\$5", $date);
        $second = preg_replace($regex, "\$6", $date);

        //echo $day.".".$month.".".$year." - ".$hour.":".$minute."<br>";
        return mktime($hour, $minute, $second, $month, $day, $year);*/
				
        return strtotime($date);
    }

    //Konvertiert von Timestamp ins DB-Datum
    function convTimestamp2Date($timestamp)
    {
        return date("Y-m-d H:i:s",$timestamp);
    }


    //
    function available()
    {

      $bool = array();
      $checked = false;
      $current_dz=mktime(0,0,0,date('m'),date('d'),date('Y'));
      $current_d=mktime(23,59,59,date('m'),date('d'),date('Y'));
      $current_dt=mktime(date('H'),date('i'),0,date('m'),date('d'),date('Y'));
      $newsletter_startdate = $this->convDate2Timestamp('', 'newsletter_startdate');
      $newsletter_starttime_yn = $this->_data['newsletter_starttime_yn'];
      $newsletter_starttime = $this->convDate2Timestamp('', 'newsletter_starttime');
      $newsletter_enddate_yn = $this->_data['newsletter_enddate_yn'];
      $newsletter_enddate = $this->convDate2Timestamp('', 'newsletter_enddate');
      $newsletter_endtime_yn = $this->_data['newsletter_endtime_yn'];
      $newsletter_endtime = $this->convDate2Timestamp('', 'newsletter_endtime');

			if ($newsletter_startdate>$current_d)
				return false;
				
			if (!empty($newsletter_starttime_yn) &&  $newsletter_starttime>$current_dt)
				return false;
				
#			if (!empty($newsletter_enddate_yn) &&  $newsletter_enddate<$current_dt)
#				return false;

			if (!empty($newsletter_endtime_yn) && !empty($newsletter_enddate_yn) &&  $newsletter_enddate<$current_dt)
				return false;

			if (!empty($newsletter_enddate_yn) &&  $newsletter_enddate<$current_dz)
				return false;
								
			if (!empty($newsletter_endtime_yn) &&  $newsletter_endtime<$current_dt)
				return false;
					
			return true;
    }
    
}


?>
