<?php
class Newslettersystem {
    //lang object
    var $lang = null;

    //cms WebRequest object
    var $cms_wr = null;
    
    //Pfad zum Plugin
    var $basedir;
    
    //ADOdb-Objekt
    var $adodb;
    
    //CMS-Vars
    var $sess;
    var $idclient;
    var $idlang;
    
    //Einstellungen
    var $settings = array();
    var $defaultval = array();
    
    var $multilang_config;
    var $multilang_tpl;
    var $multilang_newsletter;
    var $multilang_newsletter_sfcontents_langid;

    function __construct($checksetting=true) {
        global $GLOBALS, $_NL, $auth, $adodb, $cfg_cms, $client, $lang, $sess;

        $this->adodb =& $adodb;
        $this->cms_wr =& $GLOBALS['sf_factory']->getObject('HTTP', 'WebRequest');

        $this->userid =& $auth->auth['uid'];
        $this->idclient =& $client;

        $this->sess =& $sess;
        $this->cfg_cms =& $cfg_cms;

        $this->basedir =& $_NL['basedir'];

        //Default-Settings einladen
        if(file_exists($this->basedir . 'inc/cfg.defaultsettings.php')) {
            include_once $this->basedir . 'inc/cfg.defaultsettings.php';
        }

        //Objektweit verf&uuml;gbar machen
        $this->defaultval['settings'] = $defaultsettings;
        $this->defaultval['number_of_month'] = $number_of_month;
        $this->defaultval['turnus'] = $turnus;
        $this->defaultval['languages'] = $languages;
        $this->defaultval['display'] = $display;
        $this->defaultval['skins'] = $skins;

        $basesettings=array();
        $sql = "SELECT * FROM ".$cfg_cms['db_table_prefix']."plug_newslettersystem_values
                WHERE idclient=".$client." AND idlang=0 ";

        $rs = $adodb->Execute($sql);
        if ($rs === false) die("failed");
	        while (!$rs->EOF) {
	            $basesettings[$rs->fields['key2']]= $rs->fields['value'];
					$rs->MoveNext();
        }
        $rs->Close();

        if (!empty($basesettings['multilang_config']) || $basesettings['multilang_config']=='false')
            $this->multilang_config = $basesettings['multilang_config'];
				else
					 $this->multilang_config = 'true';

        if (!empty($basesettings['multilang_tpl']) || $basesettings['multilang_tpl']=='false')
            $this->multilang_tpl = $basesettings['multilang_tpl'];
				else
					 $this->multilang_tpl = 'true';

        if (!empty($basesettings['multilang_newsletter']) || $basesettings['multilang_newsletter']=='false')
            $this->multilang_newsletter = $basesettings['multilang_newsletter'];
				else
					 $this->multilang_newsletter = 'true';

        if (!empty($basesettings['multilang_newsletter_sfcontents_langid']))
            $this->multilang_newsletter_sfcontents_langid = $basesettings['multilang_newsletter_sfcontents_langid'];
				else
					 $this->multilang_newsletter_sfcontents_langid = 0;


				if ($this->multilang_config!='false')
					$this->idlang =& $lang;  
				else
					$this->idlang = 1;   

        $this->defaultval['wysiwygs'] = array("true" => "ja","false"=>"nein");
#        for ($i=1;$i<6;$i++)
#       		$this->defaultval['custom'.$i.'_label'] = ${'custom'.$i.'_label'};
        //Wenn keine Einstellungen hinzugef&uuml;gt wurden, diese laden
        if($checksetting == true) {
            $this->checkSettings();
        }
        
        $this->lang = new Lang($this->basedir . 'lang/'.$this->getSetting('language').'.php');

    }


    function checkSettings() {
	
			if ($this->multilang_config!='false')
				$langmanarr=$this->getClientLangs();
			else
				$langmanarr=array('1'=>'Name');

			foreach ($langmanarr as $lkey => $lval) {

        $defaultsettings = $this->defaultval['settings'];
        $sql = "SELECT * FROM ".$this->cfg_cms['db_table_prefix']."plug_newslettersystem_values WHERE idclient='".$this->idclient."' AND idlang='".$lkey."' AND key1='settings' ";
        $recordSet = $this->adodb->Execute($sql);
       	//echo $sql;
        if ($recordSet === false) die("failed");
        //Einstellungen in ein Array speichern
        $db_settings = $recordSet->GetArray();
        $recordSet->Close();
        
        $found = array();
        //Sind weniger Einstellungen vorhanden als vorgegeben?
        if(count($db_settings)<count($defaultsettings)) {
            //F&uuml;r jede Default-Einstellung durchlaufen
            foreach($defaultsettings as $key => $val) {
                $found[$key] = false;
                //Jede DB-Einstellung pr&uuml;fen
                for($i=0, $count = count($db_settings);$i<$count;$i++) {
                    //Gefunden und aussteigen
                    if($db_settings[$i]['key2']==$key) {
                        $found[$key] = true;
                        break;
                    }
                }
            }

            //var_dump($found);

            //F&uuml;r jedes nicht gefundene Eintragen
            foreach($found as $key => $bool) {
                if($bool == false) {
                    $record['idclient'] = $this->idclient;
                    $record['idlang'] = $lkey;
                    $record['key1'] = 'settings';
                    $record['key2'] = $key;
                    $record['value'] = $defaultsettings[$key];
                    $record['userid'] = $this->userid;
                    $record['lastedit'] = time();
                    $sql = $this->adodb->AutoExecute($this->cfg_cms['db_table_prefix']."plug_newslettersystem_values", $record, 'INSERT');

                    //Einstellungen gleich setzen
                    $this->settings[$key] = $defaultsettings[$key];
                }
            }
            if ($this->idlang == $lkey)
            	$this->loadSettings();
        
#            return true;
        }
        //Keine Eintr&auml;ge hinzugef&uuml;gt
        else {
            if ($this->idlang == $lkey)
	            $this->loadSettings();
     
#            return true;
        }
      }

    }


    function loadSettings() {
        $sql = "SELECT * FROM ".$this->cfg_cms['db_table_prefix']."plug_newslettersystem_values WHERE idclient='".$this->idclient."' AND idlang='".$this->idlang."' AND key1='settings'";
        $recordSet = $this->adodb->Execute($sql);
        if ($recordSet === false) die("failed");
        //Einstellungen in ein Array speichern
        $db_settings = $recordSet->GetArray();
        $recordSet->Close();
        
        //Jede DB-Einstellung pr&uuml;fen
        for($i=0, $count = count($db_settings);$i<$count;$i++) {
            $this->settings[$db_settings[$i]['key2']] = $db_settings[$i]['value'];
        }

        if($i>0) return true;
        else return false;
    }

    function updateSingleSetting($set='',$val='') {
    		if (empty($set) || empty($val))
    			return;
    		
        $sql = "UPDATE
                  ".$this->cfg_cms['db_table_prefix']."plug_newslettersystem_values 
                SET
                  value='".$val."'
                WHERE
                    idclient='".$this->idclient."' AND idlang='".$this->idlang."' AND key1='settings' AND key2='".$set."';";
        //echo $sql;
        $recordSet = $this->adodb->Execute($sql);
        if ($recordSet === false) die("failed");
        //Einstellungen in ein Array speichern
        $recordSet->Close();
     }


    function getSetting($key,$transform=false) {
        if(isset($this->settings[$key])) {
        		if ($transform)
    					return htmlentities($this->settings[$key],ENT_COMPAT,'UTF-8');
						else
							return $this->settings[$key];
        } else {
            return false;
        }
    }
    
    
    function getClientLangs() {
        $sql = "SELECT
                    A.idlang, A.name
                FROM
                    ".$this->cfg_cms['db_table_prefix']."lang A
                LEFT JOIN
                    ".$this->cfg_cms['db_table_prefix']."clients_lang B USING(idlang)
                WHERE
                    B.idclient='".$this->idclient."'
                ORDER BY
                    idlang";
        $recordSet = $this->adodb->Execute($sql);

        $return_arr = array();
        while (!$recordSet->EOF) {
            $return_arr[$recordSet->fields[0]] = $recordSet->fields[1];
            $recordSet->MoveNext();
        }
        $recordSet->Close();
        
        return $return_arr;
    }
    

    function getCategory() {

        if ($this->multilang_tpl!='false')
					$langman=$this->idlang;
				else
					$langman=1;    

        $sql = "SELECT
                    idtemplate, name
                FROM
                    ".$this->cfg_cms['db_table_prefix']."plug_newslettersystem_template
                WHERE
                    idclient='".$this->idclient."' AND idlang='".$langman."'
                ORDER BY
                    name ASC";
        $recordSet = $this->adodb->Execute($sql);

        $return_arr = array();
        while (!$recordSet->EOF) {
            $return_arr[$recordSet->fields[0]] = $recordSet->fields[1];
            $recordSet->MoveNext();
        }
        $recordSet->Close();

        return $return_arr;
    }


    function getNavigation() {
        global $perm;

        $area = $this->cms_wr -> getVal('area');
        $subarea = $this->cms_wr -> getVal('subarea');
        $action = $this->cms_wr -> getVal('action');

        switch($subarea) {
            case 'status':
                switch($action) {
                    default:
                        $action = 'show_status';
                }
                $subarea = 'status';
            break;
            case 'bounce':
                switch($action) {
                    default:
                        $action = 'show_bounce';
                }
                $subarea = 'bounce';
            break;
            
            case 'reciever':
                switch($action) {
                    default:
                        $action = 'show_reciever';
                }
                $subarea = 'reciever';
            break;
            
            case 'template':
                switch($action) {
                    case 'save_template':
                    default:
                        $action = 'show_template';
                }
                $subarea = 'template';
            break;

            case 'settings':
                switch($action) {
                    case 'save_settings':
                    default:
                        $action = 'show_settings';
                }
                $subarea = 'settings';
            break;

            case 'archive':
                switch($action) {
                    case 'dupl_newsletter':
                    case 'edit_newsletter':
                    case 'save_newsletter':
                        $action = 'edit_newsletter';
                      break;
                    case 'switch_online':
                    case 'switch_offline':
                    case 'delete_newsletter':
                    default:
                    $action = 'show_newsletter';
                }
                $subarea = 'archive';
            break;

            case 'newsletter':
            default:
                switch($action) {
                    case 'new_newsletter':
                        $action = 'new_newsletter';
                      break;
                    case 'dupl_newsletter':
                    case 'edit_newsletter':
                    case 'save_newsletter':
                        $action = 'edit_newsletter';
                      break;
                    case 'switch_online':
                    case 'switch_offline':
                    case 'delete_newsletter':
                    default:
                    $action = 'show_newsletter';
                }
                $subarea = 'newsletter';
            break;
        }

        $_url['newsletter'] = $this->sess->url($cfg_cms['cms_html_path'].'main.php?area=plugin&cms_plugin=newslettersystem/index.php&subarea=newsletter&action=show_newsletter');
        $_url['archive'] = $this->sess->url($cfg_cms['cms_html_path'].'main.php?area=plugin&cms_plugin=newslettersystem/index.php&subarea=archive&action=show_newsletter');
	      $_url['status'] = $this->sess->url($cfg_cms['cms_html_path'].'main.php?area=plugin&cms_plugin=newslettersystem/index.php&subarea=status&action=show_status');
	      $_url['bounce'] = $this->sess->url($cfg_cms['cms_html_path'].'main.php?area=plugin&cms_plugin=newslettersystem/index.php&subarea=bounce&action=show_bounce');
	      $_url['reciever'] = $this->sess->url($cfg_cms['cms_html_path'].'main.php?area=plugin&cms_plugin=newslettersystem/index.php&subarea=reciever&action=show_reciever');
	      $_url['template'] = $this->sess->url($cfg_cms['cms_html_path'].'main.php?area=plugin&cms_plugin=newslettersystem/index.php&subarea=template&action=show_template');
        $_url['settings'] =  $this->sess->url($cfg_cms['cms_html_path'].'main.php?area=plugin&cms_plugin=newslettersystem/index.php&subarea=settings&action=show_settings');

        $_css['newsletter'] = ($subarea == 'newsletter') ? ' style="font-weight:bold;background-image:url(tpl/'.$this->cfg_cms['skin'].'/img/bg_header_active_sub.gif);"' : '';
        $_css['archive'] = ($subarea == 'archive') ? ' style="font-weight:bold;background-image:url(tpl/'.$this->cfg_cms['skin'].'/img/bg_header_active_sub.gif);"' : '';
        $_css['status'] = ($subarea == 'status') ? ' style="font-weight:bold;background-image:url(tpl/'.$this->cfg_cms['skin'].'/img/bg_header_active_sub.gif);"' : '';
        $_css['bounce'] = ($subarea == 'bounce') ? ' style="font-weight:bold;background-image:url(tpl/'.$this->cfg_cms['skin'].'/img/bg_header_active_sub.gif);"' : '';
        $_css['reciever'] = ($subarea == 'reciever') ? ' style="font-weight:bold;background-image:url(tpl/'.$this->cfg_cms['skin'].'/img/bg_header_active_sub.gif);"' : '';
        $_css['template'] = ($subarea == 'template') ? ' style="font-weight:bold;background-image:url(tpl/'.$this->cfg_cms['skin'].'/img/bg_header_active_sub.gif);"' : '';
        $_css['settings'] = ($subarea == 'settings') ? ' style="font-weight:bold;background-image:url(tpl/'.$this->cfg_cms['skin'].'/img/bg_header_active_sub.gif);"' : '';
        
        //Tpl einladen
        include_once $this->basedir . 'tpl/'.$this->cfg_cms['skin'].'/tpl.be_navi.php';


        $_tpl['newsletter'] = str_replace(array(
								'{area}',
								'{url}',
								'{css}'
								),
							array(
								$this->lang->get('area_newsletter'),
								$_url['newsletter'],
								$_css['newsletter']
              ),
							$_NL['tpl']['navi_link']);

				if($this->getSetting('use_archive') == 1)
	        $_tpl['archive'] = str_replace(array(
									'{area}',
									'{url}',
									'{css}'
									),
								array(
									$this->lang->get('area_archive'),
									$_url['archive'],
									$_css['archive']
	              ),
								$_NL['tpl']['navi_link']);

        if($perm->have_perm(2, 'area_plug_newslettersystem' ,0) == true) {
            $_tpl['status'] = str_replace(array(
								'{area}',
								'{url}',
								'{css}'
								),
							array(
								$this->lang->get('area_status'),
								$_url['status'],
								$_css['status']
              ),
							$_NL['tpl']['navi_link']);
				}
        if($perm->have_perm(3, 'area_plug_newslettersystem' ,0) == true) {
            $_tpl['bounce'] = str_replace(array(
								'{area}',
								'{url}',
								'{css}'
								),
							array(
								$this->lang->get('area_bounce'),
								$_url['bounce'],
								$_css['bounce']
              ),
							$_NL['tpl']['navi_link']);
				}

        if($perm->have_perm(6, 'area_plug_newslettersystem' ,0) == true) {
            $_tpl['reciever'] = str_replace(array(
								'{area}',
								'{url}',
								'{css}'
								),
							array(
								$this->lang->get('area_reciever'),
								$_url['reciever'],
								$_css['reciever']
              ),
							$_NL['tpl']['navi_link']);
				}

        if($perm->have_perm(4, 'area_plug_newslettersystem' ,0) == true) {
            $_tpl['template'] = str_replace(array(
								'{area}',
								'{url}',
								'{css}'
								),
							array(
								$this->lang->get('area_template'),
								$_url['template'],
								$_css['template']
              ),
							$_NL['tpl']['navi_link']);
        }
        
        if($perm->have_perm(5, 'area_plug_newslettersystem' ,0) == true) {
            $_tpl['settings'] = str_replace(array(
								'{area}',
								'{url}',
								'{css}'
								),
							array(
								$this->lang->get('area_settings'),
								$_url['settings'],
								$_css['settings']
              ),
							$_NL['tpl']['navi_link']);
				}
				
        $_tpl['links'] = implode("", $_tpl);				

        $_tpl_out = str_replace(array(
								'{area}',
								'{subarea}',
								'{action}',
								'{links}',
								'{sf_skin}'

								),
							array(
								$this->lang->get('area'),
								$this->lang->get('area_newsletter'),
								' - '.(($subarea=='archive')?$this->lang->get('action_show_'.$subarea):$this->lang->get('action_'.$action)),
				        $_tpl['links'],
				        $this->cfg_cms['skin']
								),
							$_NL['tpl']['be_navi']);

        echo $_tpl_out;

    }
    

    function getSelectMonthBack($fieldname='', $selected_month=-1, $style=' style="font-weight:bold;"', $onclick='', $option_showrange=false) {
        $months = $this->defaultval['number_of_month'];
        
        $output = '<select name="'.$fieldname.'" size="1"'.$onclick.'>';
        if($option_showrange == true) {
            $output .= '<option value="" selected="selected">'.$this->lang->get('showrange').'</option>';
        }
		
        foreach($months as $number ) {
            if($number == -1) {
              $lng = $this->lang->get('all');
            } else if($number < 12) {
              $lng = ($number == 1) ? $number." ".$this->lang->get('month') : $number." ".$this->lang->get('month_plural');
            } else {
              $lng = ($number == 12) ? ($number/12)." ".$this->lang->get('year') : ($number/12)." ".$this->lang->get('year_plural');
            }

            $selected = ($selected_month == $number) ? $style : '';
            $output .= '
            <option value="'.$number.'"'.$selected.'>'.$lng.'</option>';
        }
        $output .= '
        </select>';
        
        return $output;
    }


    function getSelectLanguage($fieldname, $selected_language='') {
        $languages = $this->defaultval['languages'];

        $output = '<select name="'.$fieldname.'" size="1">';
        foreach($languages as $language ) {
            $selected = ($selected_language == $language) ? ' selected="selected"' : '';
            $output .= '
            <option value="'.$language.'"'.$selected.'>'.$language.'</option>';
        }
        $output .= '
        </select>';

        return $output;
    }


    function getSelectSkin($fieldname, $selected_skin='') {
        $skins = $this->defaultval['skins'];

        $output = '<select name="'.$fieldname.'" size="1">';
        foreach($skins as $skin ) {
            $selected = ($selected_skin == $skin) ? ' selected="selected"' : '';
            $output .= '
            <option value="'.$skin.'"'.$selected.'>'.$skin.'</option>';
        }
        $output .= '
        </select>';

        return $output;
    }


    
    function getSelectUni($fieldname, $selected_uni,$unis=array(),$fieldid="",$fieldonchange="",$fieldatrcustom="size=1") {

        $output = '<select '.
        					((!empty($fieldid))?'id="'.$fieldid.'"':'').
        					' name="'.$fieldname.'" '.
        					((!empty($fieldatrcustom))?$fieldatrcustom:'').
        					((!empty($fieldonchange))?' onchange="'.$fieldonchange.'"':'').'>';
					if (is_array($unis))
		        foreach($unis as $uni => $v) {
			        if (is_array($selected_uni))
									$selected = (in_array($uni,$selected_uni)) ? ' selected="selected"' : '';
							else
			            $selected = ($selected_uni == $uni) ? ' selected="selected"' : '';
			         
			         $output .= '
			            <option value="'.$uni.'"'.$selected.'>'.$v.'</option>';
		        }
        $output .= '
        </select>';

        return $output;
    }
}




?>
