<?php
//Wenn die Klasse Array Iterator nicht vorhanden ist, laden
if(!class_exists('NlArrayIterator')) {
    include_once str_replace ('\\', '/', dirname(__FILE__) . '/') . 'class.arrayiterator.php';
}

class TemplateCollection {
        var $_data = array();
        var $_env = array(
                'key1' => 'settings'
            );

        //Anzahl der Eintr&auml;ge einschr&auml;nken
        /* $lines = Anzahl der Zeilen
          $offset = Starte ab dieser Zeile */
        function setLimit($lines, $offset="0") {
            if(!is_numeric($offset)) {
                $this->writeError('offset <b>'.$offset.'</b> is not numeric', __FILE__, __CLASS__, __FUNCTION__);
                return false;
            } else if(!is_numeric($lines)) {
                $this->writeError('lines <b>'.$lines.'</b> is not numeric', __FILE__, __CLASS__, __FUNCTION__);
                return false;
            } else {
                $this->_env['limit'] = " LIMIT ".$offset.",".$lines;
                return true;
            }
        }
        
        
        function generate() {
            global $adodb, $client, $lang, $cfg_cms,$_NL;
            
            $this->_data = array();

            if ($_NL['newsletter_obj']->multilang_tpl!='false')
							$langman=$lang;
						else
							$langman=1;

            //zusaetzlich generieren: Kategoriename, Veranstaltername
            $sql = "SELECT
                        *
                    FROM
                        ".$cfg_cms['db_table_prefix']."plug_newslettersystem_template
                    WHERE
                        idclient=".$client." #AND
                        #idlang=".$langman." AND
                    ORDER BY
                   			idlang ASC,
                    		name ASC,
                        hash ASC
                        ".$this->_env['limit'];

            //echo $sql;

            $rs = $adodb->Execute($sql);
            if ($rs === false) die("failed");

            while (!$rs->EOF) {
                $item = new SingleTemplate();
                $_data = array(
                    'idtemplate' => $rs->fields['idtemplate'],
                    'idclient' => $rs->fields['idclient'],
                    'idlang' => $rs->fields['idlang'],
                    'online' => $rs->fields['online'],
                    'name' => $rs->fields['name'],
                    'textmail' => $rs->fields['textmail'],
                    'htmlmail' => $rs->fields['htmlmail'],
                    'comment' => $rs->fields['comment'],
                    'userid' => $rs->fields['userid'],
                    'lastedit' => $rs->fields['lastedit'],
                    'hash' => $rs->fields['hash']
                );

                $item->loadByData($_data);
                array_push($this->_data, $item);

                $rs->MoveNext();
            }

            $rs->Close();
        }

        function &get() {
            $i = new NlArrayIterator();
            $i->loadByRef($this->_data);
            return $i;
        }

        //alle treffer andrucken
        function count() {
            return count($this->_data);
        }

        //Gibt eine Fehlermeldung aus
        function writeError($msg, $file, $class, $function)
        {
            if($this->error_report==true) //Fehlermeldung ausgeben?
            {
                echo '<strong>Error:</strong> '.$msg.' <br /><strong>File:</strong> '.$file.'<br /><strong>Class:</strong> '.$class.'<br /><strong>Function:</strong> '.$function.'()';
            }
            return false;
        }
}




class SingleTemplate {
    var $_data = array(
        'idtemplate' => '0',
        'idclient' =>  '0',
        'idlang' =>  '0',
        'online' =>  '1',
        'name' => '',
        'textmail' => '',
        'htmlmail' => '',
        'comment' => '',
        'userid' => '',
        'lastedit' => '',
        'hash' => ''
        );
    var $_is_loaded = false;
    var $_dirty = false;

    var $_extra = array();

    function __construct() { }

    function loadById($id) {
        global $adodb, $cfg_cms;

        $sql = "SELECT
                    *
                FROM
                    ".$cfg_cms['db_table_prefix']."plug_newslettersystem_template
                WHERE
                    idtemplate='".$id."';";
#				echo $sql;
        $rs = $adodb->Execute($sql);
        if ($rs === false) die("failed");

        $_data = array(
                    'idtemplate' => $rs->fields['idtemplate'],
                    'idclient' => $rs->fields['idclient'],
                    'idlang' => $rs->fields['idlang'],
                    'online' => $rs->fields['online'],
                    'name' => $rs->fields['name'],
                    'textmail' => $rs->fields['textmail'],
                    'htmlmail' => $rs->fields['htmlmail'],
                    'comment' => $rs->fields['comment'],
                    'userid' => $rs->fields['userid'],
                    'lastedit' => $rs->fields['lastedit'],
                    'hash' => $rs->fields['hash']
        );

        $rs->Close();

        $this->loadByData($_data);
    }


    function loadByData($incoming_data, $set_dirtyflag = false) {
        foreach($incoming_data as $key => $value)
        {
            $this->_set($key, $value, $set_dirtyflag);
        }

        $this->_is_loaded = true;
    }


    function getDataByKey($key,$transform=false) {
    
    		if ($transform)
    			return htmlentities(stripslashes($this->_data[$key]),ENT_COMPAT,'UTF-8');
    
        return stripslashes($this->_data[$key]);
    }


    function _set($key, $val, $set_dirtyflag = true) {
        if (array_key_exists($key, $this->_data)) {
            $val = stripslashes($val);
            $this->_data[$key] = addslashes($val);
            if ($set_dirtyflag) {
                $this->_dirty = true;
            }
            return true;
        }

        return false;
    }

    function setData($key, $val, $set_dirtyflag = true) {
        if (array_key_exists($key, $this->_data)) {
            $val = stripslashes($val);
            $this->_data[$key] = addslashes($val);
            if ($set_dirtyflag) {
                $this->_dirty = true;
            }
            return true;
        }

        return false;
    }
    
    function _setSpecial() {
        global $client, $lang, $auth;

        $this->_set('idclient', $client, false);
        //$this->_set('idlang', $lang, false);
        $this->_set('userid', $auth->auth['uid'], false);
        $this->_set('lastedit', date("Y-m-d H:i:s"), false);
    }

    function save() {
        global $adodb, $cfg_cms; //, $_NL;

        if ($this->_dirty) {
            if ($this->_data['idtemplate'] > 0) {
                $this->_setSpecial();

                $set_sql = array();
                foreach($this->_data as $key => $value)
                {
                    $set_sql[] = $key."='".$value."'";
                }

                $sql = "UPDATE
                          ".$cfg_cms['db_table_prefix']."plug_newslettersystem_template
                        SET
                          ".implode($set_sql, ", ")."
                        WHERE
                            idtemplate='".$this->_data['idtemplate']."';";
                //echo $sql;
                $adodb->Execute($sql);
                
            } else {
                $this->_setSpecial();

                $keys_sql = array();
                $values_sql = array();
                foreach($this->_data as $key => $value)
                {
                    $values_sql[] = "'".$value."'";
                    $keys_sql[] = $key;
                }
                
                $sql = "INSERT INTO
                            ".$cfg_cms['db_table_prefix']."plug_newslettersystem_template
                             (".implode($keys_sql, ', ').")
                        VALUES
                             (".implode($values_sql, ', ').")";

                //echo $sql."<br>";
                $adodb->Execute($sql);

                //Die neue ID in das Objekt speichern, falls sie sofort gebraucht wird
                $this->setData('idtemplate', $adodb->Insert_ID());
            }

            $this->_dirty = false;
        }
    }

    function delete($id=0) {
        global $adodb, $cfg_cms;

        //Lscht alle! Kategorien eines Projektes mittels Hash
        if (!empty($this->_data['idtemplate']) && $id==0) {
            $sql = "DELETE FROM
                        ".$cfg_cms['db_table_prefix']."plug_newslettersystem_template
                    WHERE
                        idtemplate='".$this->_data['idtemplate']."'";
            //echo $sql;
            $adodb->Execute($sql);
            
        } else if ($id!=0) {
        
            $sql = "DELETE FROM
                        ".$cfg_cms['db_table_prefix']."plug_newslettersystem_template
                    WHERE
                        idtemplate='".$id."'";
            //echo $sql;
            $adodb->Execute($sql);        

        }
    }

}







?>
