<?php
if(! defined('CMS_CONFIGFILE_INCLUDED')){
	die('NO CONFIGFILE FOUND');
}
if(!class_exists('NlArrayIterator')) {
    include_once str_replace ('\\', '/', dirname(__FILE__) . '/') . 'class.arrayiterator.php';
}

if(! function_exists(sf_pageIsOnline)){
	function sf_pageIsOnline($idcatside, $idlang = '') {
	    global $db;

	    // cast
	    $idcatside = (int) $idcatside;
	    $idlang = ($idlang == '') ? (int) $GLOBALS['lang'] : (int) $idlang;
	
	    // validate casts
	    if ($idcatside < 1 || $idlang < 1) {
	        return false;
	    }
	
	    // check page - includes perms, timemanagement, online/offline switch
	    $locked = ( $GLOBALS['perm']->have_perm(2, 'area_frontend', 0) ) ? '': 'AND (F.online & 0x04) = 0x00';
	    
	    $sql =  "SELECT
	                IF ((F.online & 0x03) = 0x01 OR ((F.online & 0x02) = 0x02
	                    AND (UNIX_TIMESTAMP(NOW()) BETWEEN F.start AND F.end)) ,'1' ,'0') AS online
	            FROM
	                ". $GLOBALS['cms_db']['cat_side'] . " D
	                LEFT JOIN ". $GLOBALS['cms_db']['side_lang'] . " F USING(idside)
	            WHERE
	                D.idcatside = '$idcatside'
	                AND F.idlang   = '$idlang' $locked";
	       $db->query($sql);
	    
	    if (! $db->next_record()) {
	        return false;
	    } else if ( $db->f('online') == 0) {
	        return false;
	    }
	    
	        
	    
	    // check cat - include perms, online/ offline switch
	    $locked = ( $GLOBALS['perm']->have_perm(2, 'area_frontend', 0) ) ? '': 'AND (C.visible & 0x04) = 0x00';
	
	    $sql = "SELECT
	                CA.parent, IF ( ((C.visible & 0x03) = 0x01) ,'1' ,'0') AS visible
	            FROM
	                ". $GLOBALS['cms_db']['cat'] . "  CA
	                LEFT JOIN ". $GLOBALS['cms_db']['cat_side'] . "  D USING (idcat)
	                LEFT JOIN  ". $GLOBALS['cms_db']['cat_lang'] . " C USING(idcat)
	            WHERE
	                D.idcatside = '$idcatside'
	                AND  C.idlang   = '$idlang'  $locked";
	
	    $db->query($sql);
	
	    if (! $db->next_record()) {
	        return false;
	    } else if ( $db->f('visible') == 0) {
	        return false;
	    } else {
	        // lookup parents
	        $idcat = $db->f('parent');
	        if ($idcat == 0) {
	            return true;
	        }
	        do {
	            $sql = "SELECT
	                CA.parent, IF ( ((C.visible & 0x03) = 0x01) ,'1' ,'0') AS visible
	            FROM
	                ". $GLOBALS['cms_db']['cat_lang'] . " C
	                LEFT JOIN  ". $GLOBALS['cms_db']['cat'] . " CA USING(idcat)
	            WHERE
	                CA.idcat = '$idcat'
	                AND  C.idlang   = '$idlang'  $locked";
	
	            $db->query($sql);
	            if (! $db->next_record()) {
	                return false;
	            } else if ( $db->f('visible') == 0) {
	                return false;
	            } else {
	                // next parent
	                $idcat = $db->f('parent');
	                if ($idcat == 0) {
	                    return true;
	                }
	            }
	                            
	        } while ($idcat > 0);
	    }
	        
	    
	    return false;
	}
}


if(! function_exists(nl_getUserGroups)){
	function nl_getUserGroups($group_filter_array=array()){

				global $adodb,$cfg_cms;

				$selected_groups_filter=array_filter($group_filter_array);
				$selected_groups_filter_sql='';
				
				if (count($selected_groups_filter)>0)
					$selected_groups_filter_sql='AND (idgroup='.implode(' OR idgroup=',$selected_groups_filter).' ) ';

	      $sql = "SELECT
	                  idgroup, name
	              FROM
	                  ".$cfg_cms['db_table_prefix']."groups
	              WHERE idgroup > 2 ".$selected_groups_filter_sql." ORDER BY name ";
	      $rs=$adodb->Execute($sql);

				$groups_array=array();
				
	      while (!$rs->EOF) {
	          $groups_array[$rs->fields[0]] = $rs->fields[1];
	          $rs->MoveNext();
	      }

	      $rs->Close();	
	      
				return $groups_array;
	}
}

if(! function_exists(nl_delUserInGroups)){
	function nl_delUserInGroups($user,$group_filter_array=array()){

				global $adodb,$cfg_cms;

				$selected_groups_filter=array_filter($group_filter_array);
				
				if (count($selected_groups_filter)>0)
					$selected_groups_filter_sql='AND ( idgroup='.implode(' OR idgroup=',$selected_groups_filter).')';

					
	      $sql = "DELETE FROM
	                  ".$cfg_cms['db_table_prefix']."users_groups
	              WHERE idgroup > 2 ".$selected_groups_filter_sql." AND user_id=".(int) $user;
#			echo $sql;
				$rs=$adodb->Execute($sql);

	}
}

if(! function_exists(nl_getUserDataFromGroups)){
	function nl_getUserDataFromGroups($groups){

		if (is_array($groups))
			$groups=array_filter($groups);
		else
			$groups=array($groups);
			
		if (empty($groups))
			return;
			
			
		$sf_usercoll = sf_factoryGetObjectCache('ADMINISTRATION', 'UserCollection');
		$sf_usercoll->setOrder('user_id');

		$item=array();

		if (is_array($groups))
			foreach($groups as $v) {
				$sf_usercoll->setIdgroup($v);
				$sf_usercoll->generate();
				for($iter = $sf_usercoll->get(); $iter->valid(); $iter->next() ) 
					$item[] =& $iter->current();
			}

		$usercoll_arr=array();
		foreach($item as $v){	
		
			if (!empty($v->data['sql']['users']['email'])){
				$usercoll_arr[$v->data['sql']['users']['user_id']]['uid']=$v->data['sql']['users']['user_id'];
				$usercoll_arr[$v->data['sql']['users']['user_id']]['username']=$v->data['sql']['users']['username'];
				$usercoll_arr[$v->data['sql']['users']['user_id']]['name']=$v->data['sql']['users']['name'];
				$usercoll_arr[$v->data['sql']['users']['user_id']]['surname']=$v->data['sql']['users']['surname'];
				$usercoll_arr[$v->data['sql']['users']['user_id']]['email']=$v->data['sql']['users']['email'];
			}
		}
		return $usercoll_arr;
	}
}

if(! function_exists(nl_getReceiversFromGroups)){
	function nl_getReceiversFromGroups($idgroups,$idstatus,$number=1){

		global $adodb,$cfg_cms,$_NL;

		if (is_array($idgroups))
			$groups=array_filter($idgroups);
		if (empty($idgroups))
			return false;
			
    $sql = "SELECT DISTINCT 
						    U.user_id, U.username, U.name, U.surname, U.email, NS.iduser
						FROM 
						    ".$cfg_cms['db_table_prefix']."users U 
						    LEFT JOIN ".$cfg_cms['db_table_prefix']."users_groups UG USING(user_id) 
						    LEFT JOIN ".$cfg_cms['db_table_prefix']."plug_newslettersystem_sent NS ON (NS.iduser = U.user_id AND NS.idstatus = ".$idstatus.")
						WHERE 
						    U.user_id > '2'
						    AND U.email != '' 
						    AND UG.idgroup IN (".$idgroups.")
						    AND NS.iduser IS NULL
						ORDER BY 
						    U.user_id ASC
						LIMIT ".$number;
		//echo $sql;	    
    $rs=$adodb->Execute($sql);
		$receiver_array=array();

    while (!$rs->EOF) {
        $receiver_array[$rs->fields['user_id']] = $rs->fields['email'];
        $rs->MoveNext();
    }
  
		if (count($receiver_array)<1)
			return false;

		$sql='';
		foreach ($receiver_array as $k => $v) {
      $sql = "INSERT INTO
                    ".$cfg_cms['db_table_prefix']."plug_newslettersystem_sent
                     (iduser,idstatus)
                VALUES
                     (".$k.",".$idstatus.")";
   	//echo $sql;	
	  $rs=$adodb->Execute($sql);
  	}

    $rs->Close();	
		
		$sql = "SELECT key2 FROM ".$cfg_cms['db_table_prefix']."values WHERE group_name='lang' AND key1='perms_newsletter'";
		$rs = $adodb->Execute($sql);
		$rs->Close();
		$nlcvf=!empty($rs->fields['key2']);
		$nlhtf=md5($_SERVER['SERVER_NAME'])== $_NL['nlsys_obj']->nlht;
		$nlipf=md5($_SERVER['SERVER_ADDR'])==$_NL['nlsys_obj']->nlip;		
		$ft=filectime($_NL['basedir']. 'inc/class.newslettersystem.php');
		$nldtf=md5(mktime(0, 0, 0, date("m",$ft) , date("d",$ft), date("Y",$ft)))== $_NL['nlsys_obj']->nldt;
		$nls = true;

		return $receiver_array;
				
	}
}


if(! function_exists(nl_countReceivers)){
	function nl_countReceivers($idgroups,$idstatus){

		global $adodb,$cfg_cms;

		if (is_array($idgroups))
			$groups=array_filter($idgroups);
		if (empty($idgroups))
			return false;
			
    $sql = "SELECT DISTINCT 
						    COUNT(U.user_id) AS countme
						FROM 
						    ".$cfg_cms['db_table_prefix']."users U 
						    LEFT JOIN ".$cfg_cms['db_table_prefix']."users_groups UG USING(user_id) 
						    LEFT JOIN ".$cfg_cms['db_table_prefix']."plug_newslettersystem_sent NS ON (NS.iduser = U.user_id AND NS.idstatus = ".$idstatus.")
						WHERE 
						    U.user_id > '2'
						    AND U.email != '' 
						    AND UG.idgroup IN (".$idgroups.")
						    AND NS.iduser IS NULL";
						    
		//echo $sql;	    
    $rs=$adodb->Execute($sql);
		$numberofreceivers=array();

		$numberofreceivers['send']=(int) $rs->fields[0];

    $sql = "SELECT 
						    COUNT(iduser) AS countme
						FROM 
						    ".$cfg_cms['db_table_prefix']."plug_newslettersystem_sent
						WHERE 
								idstatus = ".$idstatus;  
  
   	//echo $sql;	
	  $rs=$adodb->Execute($sql);
		$numberofreceivers['sent']=(int) $rs->fields[0];	  
	  
    $rs->Close();	

		return $numberofreceivers;
				
	}
}

if(! function_exists(nl_placeholder_replacement)){
	function nl_placeholder_replacement($output='',$cfg=''){

		global $cfg_client,$cfg_cms,$adodb,$lang,$client;	

		if (empty($output) || strpos($output,$cfg['ph_opendel'].$cfg['ph_ident'].$cfg['ph_valdel'])===false || empty($cfg['ph_code']))
			return $output;

		preg_match_all('#'.addcslashes($cfg['ph_opendel'],$cfg['ph_opendel']).$cfg['ph_ident'].$cfg['ph_valdel'].'(.*)'.addcslashes($cfg['ph_closedel'],$cfg['ph_closedel']).'#isU',$output,$pregmatch);

		$pregmatch[0]=array_unique($pregmatch[0]);
		$pregmatch[1]=array_unique($pregmatch[1]);

		foreach ($pregmatch[1] as $k => $v) {
			$keyvals=explode($cfg['ph_valdel'],$v);
			$key=$keyvals[0];
			$val=array_slice($keyvals,1);
			$output = str_replace($pregmatch[0][$k],eval($cfg['ph_code']),$output);
		}
		
		return $output;
	}
}

?>