<?

	
if(! function_exists(nl_str_chop)){
	/**
	* Chop a string into a smaller string.
	* @author			Aidan Lister <aidan@php.net>
	* @author2		Alexander M. Korn <amk@gmx.info>
	* @version		?
	* @link				http://aidanlister.com/repos/v/function.str_chop.php
	* @param				mixed	 $string	 The string you want to shorten
	* @param				int		 $length	 The length you want to shorten the string to
	* @param				bool	 $center	 If true, chop in the middle of the string
	* @param				mixed	 $append	 String appended if it is shortened
	*/
	function nl_str_chop($string, $length = 60, $center = true, $append = null)
	{

		$string=strip_tags($string);
		 // Set the default append string
		if ($append === null) {
				 $append = ($center === true) ? ' ... ' : ' ...';
		}
		
		preg_match_all('#\&(.*)\;#sU',$string,$entities);
		$entities[0]=array_unique($entities[0]);
		if (is_array($entities[0]) && !empty($entities[0]))
			foreach($entities[0] as $v)
				$string=(str_replace( $v,utf8_encode(html_entity_decode( $v)),$string));
		
		if ($center==="true")
			$center=true;			
		
		 // Get some measurements
		 $len_string = strlen($string);
		 $len_append = strlen($append);
		 
		if ($len_string > $length) {
			
		 // If the string is longer than the maximum length, we need to chop it
		 
				 // Check if we want to chop it in half
			if ($center === true) {
				// Get the lengths of each segment
				$len_start = $length / 2;
				$len_end = $len_start - $len_append;
				
				// Get each segment
				$seg_start = substr($string, 0, $len_start);
				$seg_end = substr($string, $len_string - $len_end, $len_end);
				
				$seg_start = substr( $seg_start, 0, strrpos ( $seg_start, " "));
				$seg_end = substr( $seg_end, strpos ( $seg_end, " ")+1);
				
				// Stick them together
				$string = $seg_start . $append . $seg_end;
			} else {
				// Otherwise, just chop the end off
				$string = substr($string, 0, $length - $len_append);
				$string = substr($string, 0, strrpos ($string, " ")) . $append;
			}
		} 
		return $string;	
	}
}

//
//
//

if(! function_exists(nl_cleanstring)){
	function nl_cleanstring($string)
	{
		//Leerzeichen raus
		$string = trim($string);

		//Sonderzeichen raus
		$string = str_replace("","ae", $string);
		$string = str_replace("","Ae", $string);
		$string = str_replace("","ue", $string);
		$string = str_replace("","Ue", $string);
		$string = str_replace("","oe", $string);
		$string = str_replace("","Oe", $string);
		$string = str_replace("","ss", $string);
		$string = str_replace("+","-", $string);
		$string = str_replace(":","_", $string);
		$string = str_replace("!","_", $string);
		$string = str_replace("&","_", $string);
		$string = str_replace("","_", $string);
		$string = str_replace("","_", $string);	
		$string = str_replace('"','', $string);		
		$string = str_replace("'","", $string);	
		$string = str_replace(" ","_", $string);	
		
		//Weiteres...
		$string = str_replace(",","", $string);

		return $string;
	}
}

//
//
//

if(! function_exists(nl_url_creator)){

	function nl_url_creator($doc,$vars)
	{
		global $_NL,$cfg_client,$sess,$view;
		$doc=str_replace('&amp;','&',$doc);
		$url=str_replace('&','&amp;',$doc);
		
		if ($cfg_client['url_rewrite']==0 || ($sess->name == 'sefrengo' && ($view == 'edit' || $view == 'preview' )))
			$bw='&amp;';
		else
			$bw='?';
		foreach ($vars as $k => $v) {
			if (!empty($v) || $v==='0' || $v===0)
				$url.=$bw.$_NL['modkey'].$k.'='.$v;
			$bw='&amp;';
		}
		return $url;	
	}
}

//
// init
//


include_once $_NL['basedir'] . 'inc/fnc.newsletter_utilities.php';
include_once $_NL['basedir'] . 'inc/fnc.generate_newsletter.php';
include_once $_NL['basedir'] . 'inc/class.newslettersystem.php'; //Basisklasse
include_once $_NL['basedir'] . 'inc/class.lang.php'; //Sprachobjekt
include_once $_NL['basedir'] . 'inc/paginator.php';


$_sf_content =& sf_factoryGetObjectCache('PAGE', 'ContentCollection');




$_NL['temp']=array();
if (empty($mvars[800]))
	$_NL['modkey']=$cms_mod['key'];
else
	$_NL['modkey']=nl_cleanstring($mvars[800]);

//


//CMS Webrequest erstllen
$_NL['cms_wr'] =& $GLOBALS['sf_factory']->getObject('HTTP', 'WebRequest');
$_NL['user'] =& $GLOBALS['sf_factory']->getObject('ADMINISTRATION', 'User');

//AdoDB initialtisieren
$adodb =& $GLOBALS['sf_factory']->getObject('DATABASE', 'Ado');

//Newslettersystem initializieren
$_NL['nlsys_obj'] = new Newslettersystem;

//Collectionklasse laden
include_once $_NL['basedir'] . 'inc/class.newslettercollection.php';
include_once $_NL['basedir'] . 'inc/class.elementcollection.php';

//Externe Variablen per CMS WebRequest holen
$_NL['idnewsletter'] = $_NL['cms_wr']->getVal($_NL['modkey'].'idnewsletter');

$_NL['temp']['idcatsideback']=$_NL['cms_wr']->getVal($_NL['modkey'].'idcatsideback');
if ($_NL['temp']['idcatsideback']==$idcatside)
	unset($_NL['temp']['idcatsideback']);
	
for ($i=1;$i<11;$i++)
	$_NL['temp']['customfilterselected'.$i] = $_NL['cms_wr']->getVal($_NL['modkey'].'cf'.$i);
	
//Einige Config-Vars direkt holen
$_NL['config']['date'] = str_replace( array('{day}', '{month}', '{year}'), array('d', 'm', 'Y'),$mvars[10]);
$_NL['config']['time'] = str_replace( array('{hour}', '{minute}'), array('%H', '%M'), $mvars[11]);

// create emailtemplate id<->name array for later use
$adodb =& $GLOBALS['sf_factory']->getObject('DATABASE', 'Ado');
$sql = "SELECT idtemplate, name FROM ".$cfg_cms['db_table_prefix']."plug_newslettersystem_template WHERE idclient='".$client."' AND idlang='".$lang."' ORDER BY name,hash ASC"; // AND idlang='".$idlang."'
$rs = $adodb->Execute($sql);
$_NL['temp']['templates']=array();
while (!$rs->EOF) {
    $_NL['temp']['templates'][$rs->fields[0]] = $rs->fields[1];
    $rs->MoveNext();
}
$rs->Close();

$_NL['temp']['tpl_links'] = $mvars[760];	
$_NL['temp']['sort_links'] = $mvars[780];
//
// routing preperation
//

$_NL['tpl_routing']['routings'] = array();		

if(!empty($mvars[300]) && empty($_NL['idnewsletter']) ) {

	$_NL['tpl_routing']['idcatside'] = $idcatside;
	$_NL['tpl_routing']['idcat'] = $idcat;

	$_NL['tpl_routing']['template_temp'] = '';
	$_NL['tpl_routing']['raw'] = trim( str_replace(' ', '',$mvars[300]));

  $_NL['tpl_routing']['raw_vals'] = explode("\n", $_NL['tpl_routing']['raw']);

  foreach ($_NL['tpl_routing']['raw_vals'] AS $v) {
  	$v=trim($v);
    $_NL['tpl_routing_pieces'] = explode('>', $v);
    $_NL['tpl_routing']['routings'][ $_NL['tpl_routing_pieces']['0'] ] = $_NL['tpl_routing_pieces']['1'];
  }
  
	//source idcatside
	if (array_key_exists('idcatside:'.$idcatside, $_NL['tpl_routing']['routings'])) {
	  //idcatside to as cat
		$_NL['tpl_routing']['template_temp'] = $_NL['tpl_routing']['routings']['idcatside:'.$idcatside];
		if ($_NL['tpl_routing']['template_temp'] > 0) 
		  $_NL['routed']['template'] = $_NL['tpl_routing']['template_temp'];
	// source idcat
	} else if (array_key_exists('idcat:'.$idcat, $_NL['tpl_routing']['routings'])) { 
	  //idcat to as cat
	  $_NL['tpl_routing']['template_temp'] = $_NL['tpl_routing']['routings']['idcat:'.$idcat];
	  if ($_NL['tpl_routing']['template_temp'] > 0) 
			$_NL['routed']['template'] = $_NL['tpl_routing']['template_temp'];
	}

}

//
// sorting preperation
//
if(!empty($mvars[400]) && empty($_NL['idnewsletter']) ) {

	$_NL['sorting']['array'] = array();		

	$_NL['sorting']['raw'] = trim( str_replace(' ', '',$mvars[400]));

  $_NL['sorting']['raw_vals'] = explode("\n", $_NL['sorting']['raw']);
  foreach ($_NL['sorting']['raw_vals'] AS $v) {
    $_NL['sorting_pieces'] = explode('>', $v);
    
    if (strpos($_NL['sorting_pieces']['0'],'date')!==false || strpos($_NL['sorting_pieces']['0'],'time'))
    	$_NL['sorting_pieces']['0']='newsletter_'.$_NL['sorting_pieces']['0'];

    if (strpos($_NL['sorting_pieces']['0'],'template')!==false)
    	$_NL['sorting_pieces']['0']='id'.$_NL['sorting_pieces']['0'];
  
    $_NL['sorting']['array'][$_NL['sorting_pieces']['0']]=$_NL['sorting_pieces']['1'];
  }

}

//
// get sort from links
//

$_NL['temp']['sortlinkelements']=array();

$_NL['temp']['sortlinkelements']['SDT']='newsletter_startdate';
$_NL['temp']['sortlinkelements']['EDT']='newsletter_enddate';
$_NL['temp']['sortlinkelements']['TXT']='text';
$_NL['temp']['sortlinkelements']['TSR']='teaser';
$_NL['temp']['sortlinkelements']['TTL']='title';
for ($i=1;$i<10;$i++)
	$_NL['temp']['sortlinkelements']['CT'.$i]='custom'.$i;
$_NL['temp']['sortlinkelements']['CT0']='custom10';
	
$_NL['temp']['sortlinkvalsold']=array();
$_NL['temp']['sortlinkvalsoldtemp']=array();
$_NL['temp']['sortlinkvalsoldstring'] = $_NL['cms_wr']->getVal($_NL['modkey'].'sort');

if (!empty($_NL['temp']['sortlinkvalsoldstring'])) {
	$_NL['sorting']['array']=array();
	$_NL['temp']['sortlinkvalsoldtemp']=explode(':',$_NL['temp']['sortlinkvalsoldstring']);
	foreach ($_NL['temp']['sortlinkvalsoldtemp'] as $v)
		$_NL['temp']['sortlinkvalsold'][substr($v,0,3)]=substr($v,0,4);
		if (substr($v,3,4)=='A')
			$_NL['sorting']['array'][$_NL['temp']['sortlinkelements'][substr($v,0,3)]]='ASC';
		else if (substr($v,3,4)=='D')
			$_NL['sorting']['array'][$_NL['temp']['sortlinkelements'][substr($v,0,3)]]='DESC';
}

//
// get current template
//

$_NL['temp']['template']=$_NL['cms_wr']->getVal($_NL['modkey'].'template');

if ((empty($_NL['temp']['template']) && $_NL['temp']['template']!=="0") && empty($_NL['routed']['template'])) 
	$_NL['temp']['template']=$mvars[8];
elseif (!empty($_NL['routed']['template']))
	$_NL['temp']['template']=$_NL['routed']['template'];


//
// get current search phrase
//

$_NL['temp']['searchstring']=trim(stripslashes($_NL['cms_wr']->getVal($_NL['modkey'].'searchstring')));
// deactivates time range
if (!empty($_NL['temp']['searchstring']))
	$mvars[1]='-1';
	
	
	
//
// get custom filter
//
$_NL['temp']['customfilters']=array();
$_NL['temp']['customfilters2']=array();
for ($i=1;$i<11;$i++){
	$_NL['temp']['customfilterselected'.$i] = $_NL['cms_wr']->getVal($_NL['modkey'].'cf'.$i);
	if (!empty($_NL['temp']['customfilterselected'.$i]))
		$_NL['temp']['customfilters']['custom'.$i]=stripslashes($_NL['temp']['customfilterselected'.$i]);
		$_NL['temp']['customfilters2']['custom'.$i]=htmlentities($_NL['temp']['customfilters']['custom'.$i],ENT_COMPAT,'UTF-8');
}



//
// get startmonth and rangee
//

$_NL['temp']['startmonth2'] = $_NL['cms_wr']->getVal($_NL['modkey'].'startmonth2');
$_NL['temp']['startmonth'] = $_NL['cms_wr']->getVal($_NL['modkey'].'startmonth');
if (is_numeric($_NL['temp']['startmonth2'])) 
	$_NL['temp']['startmonth'] = $_NL['temp']['startmonth2'];
$_NL['config']['startmonth'] = (empty($_NL['temp']['startmonth']) && !is_numeric($_NL['temp']['startmonth'])) ? date("m") : $_NL['temp']['startmonth'];

$_NL['temp']['monthback'] = $_NL['cms_wr']->getVal($_NL['modkey'].'monthback');
$_NL['config']['monthback'] = (empty($_NL['temp']['monthback'])) ? $mvars[1] : $_NL['temp']['monthback'];
$_NL['config_static']['monthback']=$mvars[1];

if (empty($_NL['temp']['monthback']))
	 $_NL['config']['startmonth']= $_NL['config']['startmonth']- $_NL['config']['monthback'];


//
// 
// detail view
//
//

if(is_numeric($_NL['idnewsletter']) && $mvars['72']!='list') {

	$_NL['temp']['searchstring']=htmlentities($_NL['temp']['searchstring'],ENT_COMPAT,'UTF-8');

  //Termin intialisieren
  $_NL['item'] = new SingleNewsletter;
  $_NL['elements'] = new NewsletterElements;
  
  if ($mvars['73']=='both')
		$_NL['item']->setClearHideArchived();
	else if ($mvars['73']!='true')
		$_NL['item']->setHideArchived(true);
	else
		$_NL['item']->setHideArchived(false);
	
	$_NL['item']->setHideOffline(true);

  //Termin laden
  $_NL['item']->loadById($_NL['idnewsletter']);

	if ( (int) $_NL['item']->_data['idnewsletter']>0 ) {

	$_NL['item_elements']=$_NL['elements']->loadById($_NL['idnewsletter']);

  //Tpl in Tmp-Var kopieren
  $_NL['temp']['detail'] = $mvars[7];


	$_NL['temp']['data']	=		nl_element_replacement(	$_NL['item'],
																										$_NL['nlsys_obj'],
																										$_NL['item_elements']['image'],
																										$_NL['item_elements']['file'],
																										$_NL['item_elements']['link'],
																										$_NL['item_elements']['sfcontent'],
																										$mvars[7],
																										$_NL['config']['date'],
																										$_NL['config']['time'],
																										'html',																										
																										$mvars[700],
																										$mvars[720],
																										$mvars[740],
																										array( 1 => array (	'loopmode'				=> $mvars[10720],
																																				'container'				=> $mvars[10730],	
																																				'tpl'							=> trim($mvars[10740]),
																																				'specialstring'		=> $mvars[10750]
																																			),
																													 2 => array (	'loopmode'				=> $mvars[10820],
																																				'container'				=> $mvars[10830],	
																																				'tpl'							=> trim($mvars[10840]),
																																				'specialstring'		=> $mvars[10850]
																																			),
																													 3 => array (	'loopmode'				=> $mvars[10920],
																																				'container'				=> $mvars[10930],	
																																				'tpl'							=> trim($mvars[10940]),
																																				'specialstring'		=> $mvars[10950]
																																			)
																													),																	
																										$_NL['temp']['templates'],
																										$cfg_client['htmlpath'],
																										false);





#    $_NL['temp']['data']['organizer']				=	$_NL['item']->getDataByKey('organizer');

  //Url
	$_NL['page_nav_current_page']=$_NL['cms_wr']->getVal($_NL['modkey'].'page');

	$_NL['temp']['data']['url_back'] = nl_url_creator ( $con_side[(empty($_NL['temp']['idcatsideback'])?$idcatside:$_NL['temp']['idcatsideback'])]['link'],
																							array (	'startmonth' => $_NL['config']['startmonth'],
																											'monthback' => $_NL['config']['monthback'],
																											'template' => $_NL['temp']['template'],
																											'searchstring' => $_NL['temp']['searchstring'],
																											'page' => $_NL['page_nav_current_page'],
																											'cf1' => $_NL['temp']['customfilters2']['custom1'],
																											'cf2' => $_NL['temp']['customfilters2']['custom2'],
																											'cf3' => $_NL['temp']['customfilters2']['custom3'],
																											'cf4' => $_NL['temp']['customfilters2']['custom4'],
																											'cf5' => $_NL['temp']['customfilters2']['custom5'],
																											'cf6' => $_NL['temp']['customfilters2']['custom6'],
																											'cf7' => $_NL['temp']['customfilters2']['custom7'],
																											'cf8' => $_NL['temp']['customfilters2']['custom8'],
																											'cf9' => $_NL['temp']['customfilters2']['custom9'],
																											'cf10' => $_NL['temp']['customfilters2']['custom10'],
																											'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort')) 
																										);		

  //Ausgeben, wenn nur aktuelle gew?nscht oder alle
  if($_NL['item']->available()) {
	
		//fill template - element dependent if-statements
		foreach ($_NL['temp']['data'] as $k => $v)
			$_NL['temp']['detail']=str_replace('{'.$k.'}',$v,nl_element_ifstatements($_NL['temp']['detail'],$_NL['temp']['data'],$k,$v));
  	
  	// global if-statements
		$_NL['temp']['detail'] = nl_element_sfifstatements($_NL['temp']['detail']);


		if (strpos($_NL['temp']['detail'],'{chop}')!==false){
    	preg_match_all('#\{chop\}(.*)\{/chop\}#sU',$_NL['temp']['detail'],$_NL['temp']['chopparts']);
    	if (!empty($_NL['temp']['chopparts']))
	    	foreach ($_NL['temp']['chopparts'][1] as $k => $v)
	    		$_NL['temp']['detail']=str_replace(	$_NL['temp']['chopparts'][0][$k],
	    																				nl_str_chop($v, $mvars['1003'], $mvars['1004'], $mvars['1005']),
	    																				$_NL['temp']['detail']);
	    else
	    	$_NL['temp']['detail']=str_replace(array('{chop}','{/chop}'), array('',''), $_NL['temp']['detail']);
		}
    
    if($mvars[70]!='true')
    	echo stripslashes($_NL['temp']['detail']);

		$_NL['temp']['detail']=nl_placeholder_replacement($_NL['temp']['detail'],
																											array('ph_code' => $_NL['nlsys_obj']->getSetting('ph_code'),
																													 'ph_opendel' => $_NL['nlsys_obj']->getSetting('ph_opendel'),
																													 'ph_closedel' => $_NL['nlsys_obj']->getSetting('ph_closedel'),
																													 'ph_valdel' => $_NL['nlsys_obj']->getSetting('ph_valdel'),
																													 'ph_ident' => $_NL['nlsys_obj']->getSetting('ph_ident')
																													 ));

  
  
		// replace personalized elements
		if ((int) $_NL['cms_wr']->getVal($_NL['modkey'].'iduser')>0){
			$_NL['temp']['data']=array();
			$_NL['user']->loadByIduser($_NL['cms_wr']->getVal($_NL['modkey'].'iduser'));
			$_NL['temp']['data']['salutation']=$_NL['user']->getSalutation();
			$_NL['temp']['data']['firstname']=$_NL['user']->getName();
			$_NL['temp']['data']['lastname']=$_NL['user']->getSurname();
			$_NL['temp']['data']['iduser']=$receiversuid;
		} else {
			$_NL['temp']['data']=array();
			$_NL['temp']['data']['iduser']='';
			$_NL['temp']['data']['salutation']='';
			$_NL['temp']['data']['firstname']='';
			$_NL['temp']['data']['lastname']='';
		}
	
		foreach ($_NL['temp']['data'] as $k => $v) {
				$_NL['output']['detail']=str_replace('{'.$k.'}',$v,nl_element_ifstatements($_NL['output']['detail'],$_NL['temp']['data'],$k,$v));
		}								

  }	else
  	$_NL['temp']['detail']='';

  }	else
  	$_NL['temp']['detail']='';

  


}

//
// 
// list view
//
//


if ($mvars['72']=='list'){
	$_NL['idnewslettermem']=$_NL['idnewsletter'];
	unset($_NL['idnewsletter']);
}

if((!is_numeric($_NL['idnewsletter']) || $mvars[70]=="true") && $mvars['72']!='detail') {



  //init
  $_NL['collection'] = new NewsletterCollection();
	$_NL['elements'] = new NewsletterElements;
	
#	if (empty($mvars[3]))
#		$_NL['collection']->setLegal(mktime(0,0,0,date('m'),date('d'),date('Y')));
#	else
		$_NL['collection']->setLegal(mktime(date('H'),date('i'),0,date('m'),date('d'),date('Y')));
		
	// set template
	if($_NL['temp']['template']) 
  		$_NL['collection']->setIdtemplate($_NL['temp']['template']);

  //Offline geschaltete Termine anzeigen? NEIN!
  $_NL['collection']->setHideOffline(true);
  
  if ($mvars['73']=='both')
		$_NL['collection']->setClearHideArchived();
	else if ($mvars['73']=='true')
		$_NL['collection']->setHideArchived(false);
	else 
		$_NL['collection']->setHideArchived(true);

  //set sorting
	$_NL['collection']->setSorting();

	// set custom filters
	if (count($_NL['temp']['customfilters'])>0)
		$_NL['collection']->setCustomFilters($_NL['temp']['customfilters']);


	// time rangee switch 		
	if($mvars[1]!='-1'){
	
		// next-link check
		if (mktime(	date('H'),date('i'),date('s'),
								date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
								date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
								date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback']))) <
				mktime(	date('H'),date('i'),date('s'),
								date('m'),
								date('d'),
								date('Y'))) {
			if (empty($mvars[80])){
					$_NL['collection']->setDateRange( mktime( 0,0,0,
																										date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																										date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																										date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback']))
																									),
																						mktime(
																										date('H'),date('i'),date('s'),date('m'),date('d'),date('Y') 
																									)
																					);
			} else {
					$_NL['collection']->setDateRange( mktime( 0,0,0,
																										date('m',mktime(0,0,0,$_NL['config']['startmonth']+$_NL['config']['monthback']+1,1)),
																										date('d',mktime(0,0,0,$_NL['config']['startmonth']+$_NL['config']['monthback']+1,1)),
																										date('Y',mktime(0,0,0,$_NL['config']['startmonth']+$_NL['config']['monthback']+1,1))
																									),
																						mktime( 
																										date('H'),date('i'),date('s'),date('m'),date('d'),date('Y') 
																									)
																					);		
			}
	
			  $_NL['collection']->generate();
				$iter = $_NL['collection']->get();
				$_NL['temp']['is_next']=$iter->valid();		
			} else {
				$_NL['temp']['is_next']=false;				
			}

			if (empty($mvars[80])){
				$_NL['collection']->setDateRange( mktime(
																									0,0,0,0,0,1971
																								),
																					mktime(
																									0,0,0,
																									date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth'])),
																									date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth'])),
																									date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']))
																								)
																				);
			} else {
				$_NL['collection']->setDateRange( mktime(
																									0,0,0,0,0,1971
																								),
																					mktime(
																									0,0,0,
																									date('m',mktime(0,0,0,$_NL['config']['startmonth'])),
																									date('d',mktime(0,0,0,$_NL['config']['startmonth'])),
																									date('Y',mktime(0,0,0,$_NL['config']['startmonth']))
																								)
																				);
			}


	  $_NL['collection']->generate();
		$iter = $_NL['collection']->get();
		$_NL['temp']['is_prev']=$iter->valid();
	} else {
		$_NL['temp']['is_next']=false;	
		$_NL['temp']['is_prev']=false;	
	}

		// set custom filters
		if (count($_NL['temp']['customfilters'])>0)
			$_NL['collection']->setCustomFilters($_NL['temp']['customfilters']);

		// if searchstring is set
		if (!empty($_NL['temp']['searchstring'])) {
			$_NL['collection']->setDateRange();
			$_NL['config']['monthback']=-1;
			
			if (!empty($mvars[16]))
				$_NL['collection']->setLimit($mvars[16]);
			else
				$_NL['collection']->setLimit(50);
				
			if (!empty($mvars[15]))
				$_NL['collection']->setSearchString($_NL['temp']['searchstring'],explode(',',$mvars[15]));
			else
				$_NL['collection']->setSearchString($_NL['temp']['searchstring']);
		}

	$_NL['temp']['searchstring']=htmlentities($_NL['temp']['searchstring'],ENT_COMPAT,'UTF-8');

	// set time-range to view
	if($mvars[1]!='-1' && $_NL['config']['monthback']!=-1){
		if (empty($mvars[80])){
			if (empty($mvars[3])){
				$_NL['timestamp_rangestart']=mktime(
																							0,0,0,
																							date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth'])),
																							date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth'])),
																							date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']))
																						);
				$_NL['timestamp_rangeend']	=	mktime(
																							23,59,59,
																							date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																							date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																							date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback']))
																						);	
			} else {
				$_NL['timestamp_rangestart']=mktime(
																							0,0,0,
																							date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth'])),
																							date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth'])),
																							date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']))
																						);
				$_NL['timestamp_rangeend']	=	mktime(
																							date('H'),date('i'),59,
																							date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																							date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																							date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback']))
																						);	
			}
		} else {
			$_NL['timestamp_rangestart']=mktime(
																						0,0,0,
																						date('m',mktime(0,0,0,$_NL['config']['startmonth']+1,1)),
																						date('d',mktime(0,0,0,$_NL['config']['startmonth']+1,1)),
																						date('Y',mktime(0,0,0,$_NL['config']['startmonth']+1,1))
																					);
			if ($_NL['config']['startmonth']+$_NL['config']['monthback']>date('m')-1) {
				if (empty($mvars[3])){
					$_NL['timestamp_rangeend']	=	mktime(
																								23,59,59,
																								date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																								date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																								date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback']))
																							);
				} else {
					$_NL['timestamp_rangeend']	=	mktime(
																								date('H'),date('i'),59,
																								date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																								date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																								date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback']))
																							);
				}
			} else {
				$_NL['timestamp_rangeend']	=	mktime(
																							23,59,59,
																							date('m',mktime(23,59,59,$_NL['config']['startmonth']+$_NL['config']['monthback']+1,0)),
																							date('d',mktime(23,59,59,$_NL['config']['startmonth']+$_NL['config']['monthback']+1,0)),
																							date('Y',mktime(23,59,59,$_NL['config']['startmonth']+$_NL['config']['monthback']+1,0))
																						);				
			}
		}		
		$_NL['collection']->setDateRange($_NL['timestamp_rangestart'],$_NL['timestamp_rangeend']);
	} else {
		$_NL['timestamp_rangestart']=mktime(0,0,0,0,0,1971);	
		if (empty($mvars[3])){
			$_NL['timestamp_rangeend']	=	mktime(
																						23,59,59,
																						date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																						date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																						date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback']))
																					);
		} else {
			$_NL['timestamp_rangeend']	=	mktime(
																						date('H'),date('i'),59,
																						date('m',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																						date('d',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback'])),
																						date('Y',mktime(date('H'),date('i'),date('s'),$_NL['config']['startmonth']+$_NL['config']['monthback']))
																					);
		}

		$_NL['collection']->setDateRange($_NL['timestamp_rangestart'],$_NL['timestamp_rangeend']);
		$_NL['timestamp_rangestart']='';
		$_NL['timestamp_rangeend']='';
	}	

	$_NL['collection']->setSorting( $_NL['sorting']['array']);



  //load data
#  $_NL['collection']->generate();

#	$_NL['page_nav_items']=count($_NL['collection']->_data);
	$_NL['page_nav_items']=$_NL['collection']->countitems();

	if ($_NL['page_nav_items']>$mvars['48'] && $mvars['48']>0){
		// submited page no
		$_NL['page_nav_current_page']=$_NL['cms_wr']->getVal($_NL['modkey'].'page');
		// no submited page-no, calc the last

		if ($mvars[2]==1){
			$_NL['page_nav_pages']=ceil($_NL['page_nav_items']/$mvars['48']);
			if (empty($_NL['page_nav_current_page']))
				$_NL['page_nav_current_page']=$_NL['page_nav_pages'];
		} elseif (empty($_NL['page_nav_current_page']))
				$_NL['page_nav_current_page']=1;

		if ($mvars[2]==1)
			$_NL['collection']->setLimit($mvars['48'],-(($_NL['page_nav_current_page']*$mvars['48'])-($_NL['page_nav_pages']*$mvars['48'])));
		else
			$_NL['collection']->setLimit($mvars['48'],$mvars['48']*($_NL['page_nav_current_page']-1));			

		$_NL['pager'] = new Paginator($_NL['page_nav_current_page'],$_NL['page_nav_items']);
		//sets the number of records displayed
		//defaults to five			
		$_NL['pager']->set_Limit($mvars['48']);
		$_NL['pager']->set_Links(floor($mvars['40'])); 
		//if using numbered links this will set the number before and behind 
		//the current page.

		//gets starting point.
		$_NL['pager_limit1'] = $_NL['pager']->getRange1();	 
		//gets number of items displayed on page.
		$_NL['pager_limit2'] = $_NL['pager']->getRange2();	 
		
		$_NL['pager_links'] = $_NL['pager']->getLinkArr();
		$_NL['pager_current']=$_NL['pager']->getCurrent();			

		$_NL['pager_base_url']=	nl_url_creator( $con_side[$idcatside]['link'], 
																	array(	'startmonth' => $_NL['config']['startmonth'],
																					'monthback' => $_NL['config']['monthback'],
																					'template' => $_NL['temp']['template'],
																					'searchstring' => $_NL['temp']['searchstring'],
																					'page' => $_NL['page_nav_current_page'],
																					'cf1' => $_NL['temp']['customfilters2']['custom1'],
																					'cf2' => $_NL['temp']['customfilters2']['custom2'],
																					'cf3' => $_NL['temp']['customfilters2']['custom3'],
																					'cf4' => $_NL['temp']['customfilters2']['custom4'],
																					'cf5' => $_NL['temp']['customfilters2']['custom5'],
																					'cf6' => $_NL['temp']['customfilters2']['custom6'],
																					'cf7' => $_NL['temp']['customfilters2']['custom7'],
																					'cf8' => $_NL['temp']['customfilters2']['custom8'],
																					'cf9' => $_NL['temp']['customfilters2']['custom9'],
																					'cf10' => $_NL['temp']['customfilters2']['custom10'],
																					'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort') 
																				)  
																);

		$_NL['page_nav']='';
		$_NL['page_nav_array']=array();
		if ($_NL['pager']->getTotalPages()>1 && ((!is_numeric($_NL['idnewsletter']) || $mvars[70]=="true") && $mvars['72']!='detail') ) {

			if ($mvars[2]==1)	{		

				if($_NL['pager']->getPrevious()){
					if (!empty($mvars['43']))
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.$_NL['pager']->getFirst().'" '.$mvars['4010'].'>'.$mvars['43'].'</a>';
					if (!empty($mvars['41']))
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.$_NL['pager']->getPrevious().'" '.$mvars['4010'].'>'.$mvars['41'].'</a>';
				}
				for($i=0;$i<count($_NL['pager_links']);$i++) {
					$_NL['pager_link']=$_NL['pager_links'][$i];
					if($_NL['pager_link'] == $_NL['page_nav_current_page'])
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.$_NL['pager_link'].'" '.$mvars['4011'].'>'.($_NL['pager_link']).'</a>';
					else
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.$_NL['pager_link'].'" '.$mvars['4010'].'>'.($_NL['pager_link']).'</a>';
				}

				if($_NL['pager']->getNext()){
					if (!empty($mvars['42']))
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.$_NL['pager']->getNext().'" '.$mvars['4010'].'>'.$mvars['42'].'</a>';
					if (!empty($mvars['44']))
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.($_NL['pager']->getLast()).'" '.$mvars['4010'].'>'.$mvars['44'].'</a>';
				}

			} else {

			if($_NL['pager']->getPrevious()){	
					if (!empty($mvars['43']))
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.($_NL['pager']->getFirst()).'" '.$mvars['4010'].'>'.$mvars['43'].'</a>';
					if (!empty($mvars['41']))
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.$_NL['pager']->getPrevious().'" '.$mvars['4010'].'>'.$mvars['41'].'</a>';
				}
				for($i=0;$i<count($_NL['pager_links']);$i++) {
					$_NL['pager_link']=$_NL['pager_links'][$i];
					if($_NL['pager_link'] == $_NL['page_nav_current_page'])
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.$_NL['pager_link'].'" '.$mvars['4011'].'>'.($_NL['pager_link']).'</a>';
					else
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.$_NL['pager_link'].'" '.$mvars['4010'].'>'.($_NL['pager_link']).'</a>';
				}
				if($_NL['pager']->getNext()){	
					if (!empty($mvars['42']))
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.$_NL['pager']->getNext().'" '.$mvars['4010'].'>'.$mvars['42'].'</a>';
					if (!empty($mvars['44']))
						$_NL['page_nav_array'][] = '<a href="'.$_NL['pager_base_url'].'&amp;'.$_NL['modkey'].'page='.($_NL['pager']->getLast()).'" '.$mvars['4010'].'>'.$mvars['44'].'</a>';
				}
				
			}			

		}

		$_NL['page_nav']=implode($mvars['39'],$_NL['page_nav_array']);

		// generate again limited
    
	}

	$_NL['collection']->generate();

  $ic=0;

	if(!is_numeric($_NL['idnewsletter'])) {
  //Fr jeden geladenenen Eintrag durchlaufen
  for($iter = $_NL['collection']->get(); $iter->valid(); $iter->next() ) {

    //Aktuellen Eintrag als Objekt bereitstellen
    $_NL['item'] =& $iter->current();

		$_NL['item_elements']=$_NL['elements']->loadById($_NL['item']->getDataByKey('idnewsletter'));
		
    //Tpl in Tmp-Var kopieren
    $_NL['temp']['list_output'] = $mvars[6];

		$_NL['temp']['data']	=		nl_element_replacement(	$_NL['item'],
																											$_NL['nlsys_obj'],
																											$_NL['item_elements']['image'],
																											$_NL['item_elements']['file'],
																											$_NL['item_elements']['link'],
																											$_NL['item_elements']['sfcontent'],
																											$mvars[6],
																											$_NL['config']['date'],
																											$_NL['config']['time'],
																											'html',																										
																											$mvars[700],
																											$mvars[720],
																											$mvars[740],
																											array( 1 => array (	'loopmode'				=> $mvars[10720],
																																					'container'				=> $mvars[10730],	
																																					'tpl'							=> trim($mvars[10740]),
																																					'specialstring'		=> $mvars[10750]
																																				),
																														 2 => array (	'loopmode'				=> $mvars[10820],
																																					'container'				=> $mvars[10830],	
																																					'tpl'							=> trim($mvars[10840]),
																																					'specialstring'		=> $mvars[10850]
																																				),
																														 3 => array (	'loopmode'				=> $mvars[10920],
																																					'container'				=> $mvars[10930],	
																																					'tpl'							=> trim($mvars[10940]),
																																					'specialstring'		=> $mvars[10950]
																																				)
																														),																	
																											$_NL['temp']['templates'],
																											$cfg_client['htmlpath'],
																											false);

		$_NL['temp']['first_routed_side']=array_slice(array_filter(explode('|',$_NL['item']->getDataByKey('idtemplate'))),0,1);

    //Url
    if($mvars[70]=='true') {
    	//name='.urlencode($_NL['temp']['data']['title']).
			$_NL['temp']['data']['url'] = nl_url_creator( $con_side[$idcatside]['link'],
																						 array(	'startmonth' => $_NL['config']['startmonth'],
																										'monthback' => $_NL['config']['monthback'],
																										'idnewsletter' => $_NL['item']->getDataByKey('idnewsletter'),
																										'template' => $_NL['temp']['template'],
																										'searchstring' => $_NL['temp']['searchstring'],
																										'page' => $_NL['page_nav_current_page'],
																										'cf1' => $_NL['temp']['customfilters2']['custom1'],
																										'cf2' => $_NL['temp']['customfilters2']['custom2'],
																										'cf3' => $_NL['temp']['customfilters2']['custom3'],
																										'cf4' => $_NL['temp']['customfilters2']['custom4'],
																										'cf5' => $_NL['temp']['customfilters2']['custom5'],
																										'cf6' => $_NL['temp']['customfilters2']['custom6'],
																										'cf7' => $_NL['temp']['customfilters2']['custom7'],
																										'cf8' => $_NL['temp']['customfilters2']['custom8'],
																										'cf9' => $_NL['temp']['customfilters2']['custom9'],
																										'cf10' => $_NL['temp']['customfilters2']['custom10'],
																										'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort') 
																									) 
																									);
		} else if($mvars[71]==0) {
			
    	$_NL['temp']['routed_idcatside']=(int) str_replace('idcatside:','',array_search($_NL['temp']['first_routed_side'][0],$_NL['tpl_routing']['routings']));	
			if (!$_NL['temp']['routed_idcatside'])
				$_NL['temp']['routed_idcatside']=$idcatside;
			$_NL['temp']['data']['url'] = nl_url_creator( $con_side[$_NL['temp']['routed_idcatside']]['link'],
																						 array(	'idcatsideback' => $idcatside,
																						 				'startmonth' => $_NL['config']['startmonth'],
																										'monthback' => $_NL['config']['monthback'],
																										'idnewsletter' => $_NL['item']->getDataByKey('idnewsletter'),
																										'template' => $_NL['temp']['template'],
																										'searchstring' => $_NL['temp']['searchstring'],
																										'page' => $_NL['page_nav_current_page'],
																										'cf1' => $_NL['temp']['customfilters2']['custom1'],
																										'cf2' => $_NL['temp']['customfilters2']['custom2'],
																										'cf3' => $_NL['temp']['customfilters2']['custom3'],
																										'cf4' => $_NL['temp']['customfilters2']['custom4'],
																										'cf5' => $_NL['temp']['customfilters2']['custom5'],
																										'cf6' => $_NL['temp']['customfilters2']['custom6'],
																										'cf7' => $_NL['temp']['customfilters2']['custom7'],
																										'cf8' => $_NL['temp']['customfilters2']['custom8'],
																										'cf9' => $_NL['temp']['customfilters2']['custom9'],
																										'cf10' => $_NL['temp']['customfilters2']['custom10'],
																											'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort') 
																									) 
																									);
		} else {
			$_NL['temp']['data']['url'] = nl_url_creator( $con_side[$mvars[71]]['link'],
																						 array(	'idcatsideback' => $idcatside,
																						 				'startmonth' => $_NL['config']['startmonth'],
																										'monthback' => $_NL['config']['monthback'],
																										'idnewsletter' => $_NL['item']->getDataByKey('idnewsletter'),
																										'template' => $_NL['temp']['template'],
																										'searchstring' => $_NL['temp']['searchstring'],
																										'page' => $_NL['page_nav_current_page'],
																										'cf1' => $_NL['temp']['customfilters2']['custom1'],
																										'cf2' => $_NL['temp']['customfilters2']['custom2'],
																										'cf3' => $_NL['temp']['customfilters2']['custom3'],
																										'cf4' => $_NL['temp']['customfilters2']['custom4'],
																										'cf5' => $_NL['temp']['customfilters2']['custom5'],
																										'cf6' => $_NL['temp']['customfilters2']['custom6'],
																										'cf7' => $_NL['temp']['customfilters2']['custom7'],
																										'cf8' => $_NL['temp']['customfilters2']['custom8'],
																										'cf9' => $_NL['temp']['customfilters2']['custom9'],
																										'cf10' => $_NL['temp']['customfilters2']['custom10'],
																										'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort') 
																									)  
																									);
		}
		

    //Hinzufgen, wenn nur aktuelle gew?nscht oder alle
#    if($_NL['item']->available())  {

			//fill template
			foreach ($_NL['temp']['data'] as $k => $v){

        if ($k=='emailtemplate')
          if ($v!=$v_mem || $ic==0){
	         	$v_mem=$v;
  	       	$_NL['list']['row_temp']=$mvars[17];

				// global if-statement
				if(strpos($_NL['list']['row_temp'],'{if_emailtemplate}')!==false)
					if (empty($v))
					  $_NL['list']['row_temp'] = preg_replace('#\{if_emailtemplate\}(.*)\{/if_emailtemplate\}#sU','',$_NL['list']['row_temp']);
					else
					  $_NL['list']['row_temp'] = str_replace(array('{if_emailtemplate}','{/if_emailtemplate}'), array('',''), $_NL['list']['row_temp']);
				
				// global if-not-statement
				if(strpos($_NL['list']['row_temp'],'{if_not_emailtemplate}')!==false)
					if (empty($v))
				  	$_NL['list']['row_temp'] = str_replace(array('{if_not_emailtemplate}','{/if_not_emailtemplate}'), array('',''), $_NL['list']['row_temp']);
					else
					 	$_NL['list']['row_temp'] = preg_replace('#\{if_not_emailtemplate\}(.*)\{/if_not_emailtemplate\}#sU','',$_NL['list']['row_temp']);

					$_NL['list']['row'][]=str_replace('{emailtemplate}',$v,$_NL['list']['row_temp']);
				}
	
				//fill template - element dependent if-statements
				$_NL['temp']['list_output']=str_replace('{'.$k.'}',$v,nl_element_ifstatements($_NL['temp']['list_output'],$_NL['temp']['data'],$k,$v));

		  	// global if-statements
#				$_NL['temp']['list_output'] = nl_element_sfifstatements($_NL['temp']['list_output']);

				$_NL['temp']['list_output']=nl_placeholder_replacement($_NL['temp']['list_output'],
																																array('ph_code' => $_NL['nlsys_obj']->getSetting('ph_code'),
																																		 'ph_opendel' => $_NL['nlsys_obj']->getSetting('ph_opendel'),
																																		 'ph_closedel' => $_NL['nlsys_obj']->getSetting('ph_closedel'),
																																		 'ph_valdel' => $_NL['nlsys_obj']->getSetting('ph_valdel'),
																																		 'ph_ident' => $_NL['nlsys_obj']->getSetting('ph_ident')
																																		 ));
				
				}
        $_NL['list']['row'][] = $_NL['temp']['list_output'];

	  		$ic++;
		  		
#      }

    }
	}

	if(count($_NL['list']['row']) < 1)
		$_NL['temp']['rows'] = $mvars[9];
	else if(count($_NL['list']['row']) == 1)
	  $_NL['temp']['rows'] = $_NL['list']['row'][0];
	else
    $_NL['temp']['rows'] = implode("\n",$_NL['list']['row']);

	$_NL['output']['list_body']=$mvars[5];



if(is_numeric($_NL['idnewsletter'])) 
  $_NL['output']['list_body'] = preg_replace('#\{if_listview\}(.*)\{/if_listview\}#sU','',$_NL['output']['list_body']);
else
  $_NL['output']['list_body'] = str_replace(array('{if_listview}','{/if_listview}'), array('',''), $_NL['output']['list_body']);

if(!is_numeric($_NL['idnewsletter'])) 
  $_NL['output']['list_body'] = preg_replace('#\{if_detailview\}(.*)\{/if_detailview\}#sU','',$_NL['output']['list_body']);
else
  $_NL['output']['list_body'] = str_replace(array('{if_detailview}','{/if_detailview}'), array('',''), $_NL['output']['list_body']);



	 if($mvars[70]=='true' && is_numeric($_NL['idnewsletter']))
			$_NL['output']['list_body'] = str_replace( '{content}',$_NL['temp']['detail'],$_NL['output']['list_body']);
	elseif($_NL['collection']->count() > 0)
	    $_NL['output']['list_body'] = str_replace( '{content}',$_NL['temp']['rows'],$_NL['output']['list_body']);
	else
	    $_NL['output']['list_body'] = str_replace( '{content}',$mvars[9],$_NL['output']['list_body']);
	// replace page nav
  $_NL['output']['list_body'] = str_replace( '{page_nav}',$_NL['page_nav'],$_NL['output']['list_body']);	


	if(!empty($_NL['timestamp_rangestart']) && !empty($_NL['timestamp_rangeend'])){
		$_NL['output']['list_body'] = str_replace( '{range}',$mvars[21],$_NL['output']['list_body']);
	  $_NL['output']['list_body'] = str_replace( '{range_time_from}',strftime($_NL['config']['time'], $_NL['timestamp_rangestart']),$_NL['output']['list_body']);	
	  $_NL['output']['list_body'] = str_replace( '{range_date_from}',date($_NL['config']['date'], $_NL['timestamp_rangestart']),$_NL['output']['list_body']);	
	  $_NL['output']['list_body'] = str_replace( '{range_time_to}',strftime($_NL['config']['time'],$_NL['timestamp_rangeend']),$_NL['output']['list_body']);	
	  $_NL['output']['list_body'] = str_replace( '{range_date_to}',date($_NL['config']['date'],$_NL['timestamp_rangeend']),$_NL['output']['list_body']);	
	} else {
		$_NL['output']['list_body'] = str_replace( '{range}','',$_NL['output']['list_body']);
	}
	
if (!empty($_NL['temp']['searchstring'])) {
	
	   $_NL['output']['list_body'] = str_replace( array(
		'{link_rangebackward}',
		'{link_rangeforward}',
		'{month_form}',
		'{year_form}'
		),
		array(
			'',
	    '',
	    '',
	    ''
		),
		$_NL['output']['list_body']);

}


		
	if ($_NL['temp']['is_prev']==true) {
		$_NL['temp']['url'] = nl_url_creator( $con_side[$idcatside]['link'],
																					 array(	'idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																									'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																									'startmonth' => ($_NL['config']['startmonth']-$_NL['config_static']['monthback']),
																									'monthback' => $_NL['config_static']['monthback'],
																									'template' => $_NL['temp']['template'],
																									'cf1' => $_NL['temp']['customfilters2']['custom1'],
																									'cf2' => $_NL['temp']['customfilters2']['custom2'],
																									'cf3' => $_NL['temp']['customfilters2']['custom3'],
																									'cf4' => $_NL['temp']['customfilters2']['custom4'],
																									'cf5' => $_NL['temp']['customfilters2']['custom5'],
																									'cf6' => $_NL['temp']['customfilters2']['custom6'],
																									'cf7' => $_NL['temp']['customfilters2']['custom7'],
																									'cf8' => $_NL['temp']['customfilters2']['custom8'],
																									'cf9' => $_NL['temp']['customfilters2']['custom9'],
																									'cf10' => $_NL['temp']['customfilters2']['custom10'],
																									'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort')
																									)  
																					);
    $_NL['output']['list_body'] = str_replace( '{link_rangebackward}',
    																		str_replace('{url}',$_NL['temp']['url'],$mvars[14]),
																				$_NL['output']['list_body']);
	} else
		$_NL['output']['list_body'] = str_replace( '{link_rangebackward}','',$_NL['output']['list_body']);	


	if ($_NL['temp']['is_next']==true) {
		$_NL['temp']['url'] = nl_url_creator( $con_side[$idcatside]['link'],
																					 array(	'idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																									'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																									'startmonth' => ($_NL['config']['startmonth']+$_NL['config_static']['monthback']),
																									'monthback' => $_NL['config_static']['monthback'],
																									'template' => $_NL['temp']['template'],
																									'cf1' => $_NL['temp']['customfilters2']['custom1'],
																									'cf2' => $_NL['temp']['customfilters2']['custom2'],
																									'cf3' => $_NL['temp']['customfilters2']['custom3'],
																									'cf4' => $_NL['temp']['customfilters2']['custom4'],
																									'cf5' => $_NL['temp']['customfilters2']['custom5'],
																									'cf6' => $_NL['temp']['customfilters2']['custom6'],
																									'cf7' => $_NL['temp']['customfilters2']['custom7'],
																									'cf8' => $_NL['temp']['customfilters2']['custom8'],
																									'cf9' => $_NL['temp']['customfilters2']['custom9'],
																									'cf10' => $_NL['temp']['customfilters2']['custom10'],
																									'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort')																									
																									) 
																					);
    $_NL['output']['list_body'] = str_replace( '{link_rangeforward}',
																							  str_replace('{url}',$_NL['temp']['url'],$mvars[13]),
																								$_NL['output']['list_body']);
	} else
		$_NL['output']['list_body'] = str_replace( '{link_rangeforward}','',$_NL['output']['list_body']);	




//
// additional body elements
//

	$_NL['output']['list_body'] = str_replace('{text_label}',$_NL['nlsys_obj']->lang->get('newsletter_text'),$_NL['output']['list_body']);
	$_NL['output']['list_body'] = str_replace('{teaser_label}',$_NL['nlsys_obj']->lang->get('newsletter_teaser'),$_NL['output']['list_body']);
	$_NL['output']['list_body'] = str_replace('{title_label}',$_NL['nlsys_obj']->lang->get('newsletter_title'),$_NL['output']['list_body']);
	$_NL['output']['list_body'] = str_replace('{emailtemplate_label}',$_NL['nlsys_obj']->lang->get('newsletter_template'),$_NL['output']['list_body']);

	for ($i=1;$i<11;$i++)
		$_NL['output']['list_body'] = str_replace('{custom_label:'.$i.'}',$_NL['nlsys_obj']->getSetting('newsletter_custom'.$i.'_label'),$_NL['output']['list_body']);

//
// sort links
//

	$_NL['temp']['sortlinkvalsnew']=array();
	$_NL['temp']['sortlinkelements']=array();
	
	$_NL['temp']['sortlinkelements']['startdate_sortlink']='SDT';
	$_NL['temp']['sortlinkelements']['enddate_sortlink']='EDT';
	$_NL['temp']['sortlinkelements']['text_sortlink']='TXT';
	$_NL['temp']['sortlinkelements']['teaser_sortlink']='TSR';
	$_NL['temp']['sortlinkelements']['title_sortlink']='TTL';
	
	foreach($_NL['temp']['sortlinkelements'] as $v)
		$_NL['temp']['sortlinkvalsnew'][ $v]= $v.((substr($_NL['temp']['sortlinkvalsold'][$v],3,1)=='A')?'D':'A');
		
	for ($i=1;$i<11;$i++){
			if ($i<10)
				$_NL['temp']['sortlinkvalsnew']['CT'.$i]='CT'.$i.''.(($_NL['temp']['sortlinkvalsold']['CT'.$i]=='A')?'D':'A');
			else
				$_NL['temp']['sortlinkvalsnew']['CT0']='CT0'.(($_NL['temp']['sortlinkvalsold']['CT0']=='A')?'D':'A');
		}
	$_NL['temp']['sortlinkvalsmem']=implode(':',$_NL['temp']['sortlinkvalsnew']);

	foreach($_NL['temp']['sortlinkelements'] as $k => $v) {
		$_NL['output']['list_body'] = str_replace('{'.$k.'}',
																							'<a href="'.
																							nl_url_creator( $con_side[$idcatside]['link'],
																															array('idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																		'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																																		'monthback' => $_NL['temp']['monthback'],
																														 				'startmonth' => $_NL['temp']['startmonth'],
																														 				'searchstring' => $_NL['temp']['searchstring'],
																																		'template' => $_NL['temp']['template'] ,
																																		'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																		'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																		'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																		'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																		'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																		'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																		'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																		'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																		'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																		'cf10' => $_NL['temp']['customfilters2']['custom10'],
																																		'sort' => $v.((substr($_NL['temp']['sortlinkvalsold'][$v],3,1)=='A')?'D':'A')
																																	)  ).
																							'" '.((substr($_NL['temp']['sortlinkvalsold'][$v],3,1)=='A')?$mvars[781]:$mvars[780]).'>',
																							$_NL['output']['list_body']);
		$_NL['output']['list_body'] = str_replace('{/'.$k.'}','</a>',$_NL['output']['list_body']);
	}

	for ($i=1;$i<11;$i++) {
		if ($i<10){
			$v='CT'.$i;
		} else {
			$v='CT0';
		}
		$k='custom_sortlink:'.$i;
		$_NL['output']['list_body'] = str_replace('{'.$k.'}',
																							'<a href="'.
																							nl_url_creator( $con_side[$idcatside]['link'],
																															array('idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																		'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																																		'monthback' => $_NL['temp']['monthback'],
																														 				'startmonth' => $_NL['temp']['startmonth'],
																														 				'searchstring' => $_NL['temp']['searchstring'],
																																		'template' => $_NL['temp']['template'] ,
																																		'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																		'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																		'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																		'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																		'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																		'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																		'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																		'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																		'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																		'cf10' => $_NL['temp']['customfilters2']['custom10'],
																																		'sort' => $v.((substr($_NL['temp']['sortlinkvalsold'][$v],3,1)=='A')?'D':'A')																																		
																																	)  ).
																							'" '.((substr($_NL['temp']['sortlinkvalsold'][$v],3,1)=='A')?$mvars[781]:$mvars[780]).'>',
																							$_NL['output']['list_body']);
		$_NL['output']['list_body'] = str_replace('{/'.$k.'}','</a>',$_NL['output']['list_body']);
	}	



	//
	// custom select
	//
	for ($i=1;$i<11;$i++){
		if (strpos($_NL['output']['list_body'],'{customfilter_form:'.$i.'}')!==false){
			$_NL['temp']['customselect']['html']='';
			// start & end
			$_NL['temp']['customselect']['html']['form_start']	= '<form method="post" name="'.
																															$_NL['modkey'].'customfilterform'.$i.'" action="'.
																															nl_url_creator( $con_side[(!empty($mvars[108023])?$mvars[108023]:$idcatside)]['link'],
																																							array('idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																										'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																																										'monthback' => $_NL['temp']['monthback'],
																																						 				'startmonth' => $_NL['temp']['startmonth'],
																																						 				'searchstring' => $_NL['temp']['searchstring'],
																																										'template' => $_NL['temp']['template'] ,
																																										'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																										'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																										'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																										'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																										'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																										'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																										'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																										'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																										'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																										'cf10' => $_NL['temp']['customfilters2']['custom10']																																										
																																									)  ).																											
																															'">';
			$_NL['temp']['customselect']['html']['form_end']		= '</form>';
			
			// select
			$_NL['temp']['customselect']['html']['form_select'][] =	'<select name="'.$_NL['modkey'].'cf'.$i.'" id="'.$cms_mod['key'].'customfilter'.$i.'" size="1" '.str_replace('{form_name}',$_NL['modkey'].'customfilterform'.$i,$mvars[103023]).'>';


			$_NL['temp']['customdataarray']=array();
    	$_NL['temp']['customdatastatic']=trim($_NL['nlsys_obj']->getSetting('newsletter_custom'.$i.'_select_values'),true);

    	if (!empty($_NL['temp']['customdatastatic'])) {
	    	$_NL['temp']['customarray']=explode("\n",$_NL['temp']['customdatastatic']);

				// fill option-array with static vals
    		foreach ($_NL['temp']['customarray'] as $v) {
    			$v=stripslashes(str_replace('&amp;','&',$v));
					//$v=htmlentities($v,ENT_COMPAT,'UTF-8');
					if (!empty($v))
    				$_NL['temp']['customdataarray'][trim(htmlentities($v,ENT_COMPAT,'UTF-8'))]=trim($v);
    		}
    	}

			// fill option-array with vals from newsletters
			$sql = "SELECT custom".$i." FROM ".$cfg_cms['db_table_prefix']."plug_newslettersystem 
							WHERE online=1 AND idclient=".$client." AND idlang=".$lang;

	    $db->query($sql);
			while($db -> next_record()) {
				$v=trim($db->f('custom'.$i));
				$_NL['temp']['customdataarray'][htmlentities($v,ENT_COMPAT,'UTF-8')]=$v;
			}			
	    $_NL['temp']['customdataarray']=array_filter($_NL['temp']['customdataarray']);

			if (!empty($_NL['temp']['customdataarray']))
				$_NL['temp']['customdataarray']=array_unique($_NL['temp']['customdataarray']);

    	$_NL['temp']['customdataarray']['']=$_NL['nlsys_obj']->lang->get('newsletter_non_selected_string');

    	natcasesort($_NL['temp']['customdataarray']);


			if (is_array($_NL['temp']['customdataarray']))
				foreach ( $_NL['temp']['customdataarray'] as $k => $v)
					$_NL['temp']['customselect']['html']['form_select'][]	=	'<option value="'. $k .'" '.
																																		((htmlentities(stripslashes($_NL['temp']['customfilterselected'.$i]), ENT_COMPAT, 'UTF-8') == $k || stripslashes($_NL['temp']['customfilterselected'.$i]) == $k ) ? 'selected="selected"':'').
																																		'>'.
																																		htmlentities($v, ENT_COMPAT, 'UTF-8').
																																		'</option>'."\n";

			$_NL['temp']['customselect']['html']['form_select'][] = '</select>';
			
			// label
		  $_NL['temp']['customselect']['html']['form_label'] = '<label for="'.$cms_mod['key'].'customfilter'.$i.'" '.str_replace('{form_name}',$_NL['modkey'].'customfilterform'.$i,$mvars[104023]).'>'.$mvars[101023].'</label>';
		
			// submit
		  $_NL['temp']['customselect']['html']['form_submit'] = '<input type="submit" value="'.$mvars[105023].'" '.str_replace('{form_name}',$_NL['modkey'].'customfilterform'.$i,$mvars[107023]).' />';
	
			// complete html
			$_NL['temp']['customselect']['html']['complete'] = $_NL['temp']['customselect']['html']['form_start'].
																										  	str_replace(
																										  			array(
																										          '{custom_select}',
																										          '{custom_label}',
																										          '{custom_submit}'
																										        ),
																										        array(
																										          "\n".implode("\n",$_NL['temp']['customselect']['html']['form_select']),
																										          $_NL['temp']['customselect']['html']['form_label'],
																										          $_NL['temp']['customselect']['html']['form_submit']."\n"
																										        ),
																										        $mvars[23]).
																									        $_NL['temp']['customselect']['html']['form_end'];
	
		  $_NL['output']['list_body'] = str_replace('{customfilter_form:'.$i.'}',$_NL['temp']['customselect']['html']['complete'],$_NL['output']['list_body']);
	
		}
	}
	
		

	//
	// month / year select
	//
	
	if (strpos($_NL['output']['list_body'],'{month_form}')!==false || strpos($_NL['output']['list_body'],'{year_form}')!==false){


		// month select preparations
		$_NL['collection']->setDateRange( mktime(	0,0,0,0,0,1971 ),	mktime( date('H'),date('i'),date('s'),date('m'),date('d'),date('Y') ) );

		$_NL['collection']->setLimit();
	  $_NL['collection']->generate();

		$_NL['temp']['mselect']['avail']=array();
    for($iter = $_NL['collection']->get(); $iter->valid(); $iter->next() ) {
      $_NL['item'] =& $iter->current();
#      if($_NL['item']->available())  {
					$_NL['temp']['mselect']['avail'][date('Y',  $_NL['item']->convDate2Timestamp(0,'newsletter_startdate'))][ (int) date('m',  $_NL['item']->convDate2Timestamp(0,'newsletter_startdate'))]= (int) date('m',  $_NL['item']->convDate2Timestamp(0,'newsletter_startdate'));
#        }
    }

		// start & end
		$_NL['temp']['monthselect']['html']['form_start']	= '<form method="post" name="'.
																												$_NL['modkey'].'month" action="'.
																												nl_url_creator( $con_side[(!empty($mvars[108020])?$mvars[108020]:$idcatside)]['link'],
																																			  array('idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																							'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																																							'monthback' => 1,
																																							'template' => $_NL['temp']['template'] ,
																																							'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																							'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																							'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																							'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																							'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																							'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																							'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																							'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																							'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																							'cf10' => $_NL['temp']['customfilters2']['custom10'],
																																							'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort')																																							
																																						)  ).
																												'">';
		$_NL['temp']['monthselect']['html']['form_end']		= '</form>';
		
		// start & end
		$_NL['temp']['yearselect']['html']['form_start']	= '<form method="post" name="'.
																												$_NL['modkey'].'year" action="'.
																												nl_url_creator( $con_side[(!empty($mvars[108022])?$mvars[108022]:$idcatside)]['link'],
																																			  array('idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																							'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																																							'monthback' => 1,
																																							'template' => $_NL['temp']['template'] ,
																																							'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																							'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																							'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																							'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																							'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																							'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																							'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																							'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																							'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																							'cf10' => $_NL['temp']['customfilters2']['custom10'] ,
																																							'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort')																																							
																																						)  ).
																												'">';
		$_NL['temp']['yearselect']['html']['form_end']		= '</form>';



		// select
			$_NL['temp']['yearselect']['html']['form_select'][] ='<select name="'.$_NL['modkey'].'startmonth2" id="'.$cms_mod['key'].'startmonth2" size="1" '.str_replace('{form_name}',$_NL['modkey'].'year',$mvars[103022]).'>';
	
			// select
			$_NL['temp']['monthselect']['html']['form_select'][] ='<select name="'.$_NL['modkey'].'startmonth" id="'.$cms_mod['key'].'startmonth" size="1" '.str_replace('{form_name}',$_NL['modkey'].'month',$mvars[103020]).'>';
	

			foreach( $_NL['temp']['mselect']['avail'] as $y => $y_arr)
//			if (array_key_exists(date('Y',  mktime(0,0,0,$_NL['temp']['startmonth']+1)),$_NL['temp']['mselect']['avail']))
				foreach( $y_arr as $m) {
						$_NL['temp']['yearselect']['html']['form_select'][$y] =	'<option value="'.
																																			(in_array(date('m',  mktime(0,0,0,$_NL['temp']['startmonth']+1)),$y_arr)?
																																			((-(date('Y')-$y)*12)+date('m',  mktime(0,0,0,$_NL['temp']['startmonth']+1))-1):
																																			((-(date('Y')-$y)*12)+$m)-1).'" '.
																																			((-floor($_NL['config']['startmonth']/12) == date('Y')-$y ) ? 'selected="selected"':'').
																																			'>'.$y.'</option>';
	
				if (date('Y',  mktime(0,0,0,$_NL['temp']['startmonth']+1))==$y ||
						(date('Y',  mktime(0,0,0,$_NL['temp']['startmonth']+1))!=$y && $y==date('Y') &&
						 !array_key_exists(date('Y', mktime(0,0,0,$_NL['temp']['startmonth']+1)),$_NL['temp']['mselect']['avail'])) ) {
				if (empty($mvars[80]))
					$_NL['temp']['monthselect']['html']['form_select_from']=$_NL['nlsys_obj']->lang->get('month_'.((($m-1<1)?12:$m-1))).' - ';
				else
					$_NL['temp']['monthselect']['html']['form_select_from']='';
	
					$_NL['temp']['monthselect']['html']['form_select'][] =	'<option value="'.
																																	((-(date('Y')-$y)*12)+$m-1).'" '.
																																	(($_NL['temp']['startmonth'] == ((-(date('Y')-$y)*12)+$m-1) || (empty($_NL['temp']['startmonth']) && $_NL['config']['startmonth']==((-(date('Y')-$y)*12)+$m-1))) ? 'selected="selected"':'').
																																	'>'.
																																	htmlentities(	$_NL['temp']['monthselect']['html']['form_select_from'].$_NL['nlsys_obj']->lang->get('month_'.($m)).' ', ENT_COMPAT, 'UTF-8').
																																	'</option>';
				}
			}

			$_NL['temp']['yearselect']['html']['form_select'][] = '</select>';
			// label
		  $_NL['temp']['yearselect']['html']['form_label'] = '<label for="'.$cms_mod['key'].'startmonth2" '.str_replace('{form_name}',$_NL['modkey'].'year',$mvars[104022]).'>'.$mvars[101022].'</label>';
		
			// submit
		  $_NL['temp']['yearselect']['html']['form_submit'] = '<input type="submit" value="'.$mvars[105022].'" '.str_replace('{form_name}',$_NL['modkey'].'year',$mvars[107022]).' />';
	
			// complete html
			$_NL['temp']['yearselect']['html']['complete'] = $_NL['temp']['yearselect']['html']['form_start'].
																										  	str_replace(
																										  			array(
																										  				'{year_select}',
																										          '{year_label}',
																										          '{year_submit}'
																										        ),
																										        array(
																										        	"\n".implode("\n",$_NL['temp']['yearselect']['html']['form_select']),
																										          $_NL['temp']['yearselect']['html']['form_label'],
																										          $_NL['temp']['yearselect']['html']['form_submit']."\n"
																										        ),
																										        $mvars[22]).
																									        $_NL['temp']['yearselect']['html']['form_end'];

			if (count($_NL['temp']['yearselect']['html']['form_select'])>2)
		  	$_NL['output']['list_body'] = str_replace('{year_form}',$_NL['temp']['yearselect']['html']['complete'],$_NL['output']['list_body']);
			else
				$_NL['output']['list_body'] = str_replace('{year_form}','',$_NL['output']['list_body']);




			$_NL['temp']['monthselect']['html']['form_select'][] = '</select>';

			// label
		  $_NL['temp']['monthselect']['html']['form_label'] = '<label for="'.$cms_mod['key'].'startmonth" '.str_replace('{form_name}',$_NL['modkey'].'month',$mvars[104020]).'>'.$mvars[101020].'</label>';
		
			// submit
		  $_NL['temp']['monthselect']['html']['form_submit'] = '<input type="submit" value="'.$mvars[105020].'" '.str_replace('{form_name}',$_NL['modkey'].'month',$mvars[107020]).' />';
	
			// complete html
			$_NL['temp']['monthselect']['html']['complete'] = $_NL['temp']['monthselect']['html']['form_start'].
																										  	str_replace(
																										  			array(
																										          '{month_select}',
																										          '{month_label}',
																										          '{month_submit}'
																										        ),
																										        array(
																										          "\n".implode("\n",$_NL['temp']['monthselect']['html']['form_select']),
																										          $_NL['temp']['monthselect']['html']['form_label'],
																										          $_NL['temp']['monthselect']['html']['form_submit']."\n"
																										        ),
																										        $mvars[20]).
																									        $_NL['temp']['monthselect']['html']['form_end'];

			if (count($_NL['temp']['monthselect']['html']['form_select'])>2)
		 		$_NL['output']['list_body'] = str_replace('{month_form}',$_NL['temp']['monthselect']['html']['complete'],$_NL['output']['list_body']);
			else
				$_NL['output']['list_body'] = str_replace('{month_form}','',$_NL['output']['list_body']);
	}
	//
	// template select
	//
	if (strpos($_NL['output']['list_body'],'{emailtemplate_form}')!==false){

		// start & end
		$_NL['temp']['templateselect']['html']['form_start']	= '<form method="post" name="'.
																														$_NL['modkey'].'template" action="'.
																														nl_url_creator( $con_side[(!empty($mvars[108019])?$mvars[108019]:$idcatside)]['link'],
																																						array('idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																									'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																																									'monthback' => $_NL['temp']['monthback'],
																																					 				'startmonth' => $_NL['temp']['startmonth'],
																																					 				'searchstring' => $_NL['temp']['searchstring'],
																																									'template' => $_NL['temp']['template'] ,
																																									'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																									'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																									'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																									'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																									'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																									'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																									'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																									'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																									'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																									'cf10' => $_NL['temp']['customfilters2']['custom10'],
																																									'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort')																																									
																																								)  ).																											
																														'">';
		$_NL['temp']['templateselect']['html']['form_end']		= '</form>';
		
		// select
		$_NL['temp']['templateselect']['html']['form_select'][] =	'<select name="'.$_NL['modkey'].'template" id="'.$cms_mod['key'].'template" size="1" '.str_replace('{form_name}',$_NL['modkey'].'template',$mvars[103019]).'>';
		$_NL['temp']['templateselect']['html']['form_select'][] =	'<option value="0" '.
																															((empty($_NL['temp']['template'])) ? 'selected="selected"':'').
																															'>'.
																															$mvars[102019].
																															'</option>';
		if (is_array($_NL['temp']['templates']))
			foreach ( $_NL['temp']['templates'] as $k => $v)
				$_NL['temp']['templateselect']['html']['form_select'][]	=	'<option value="'. $k .'" '.
																																	(($_NL['temp']['template'] == $k ) ? 'selected="selected"':'').
																																	'>'.
																																	htmlentities($v, ENT_COMPAT, 'UTF-8').
																																	'</option>'."\n";

		$_NL['temp']['templateselect']['html']['form_select'][] = '</select>';
		
		// label
	  $_NL['temp']['templateselect']['html']['form_label'] = '<label for="'.$cms_mod['key'].'template" '.str_replace('{form_name}',$_NL['modkey'].'template',$mvars[104019]).'>'.$mvars[101019].'</label>';
	
		// submit
	  $_NL['temp']['templateselect']['html']['form_submit'] = '<input type="submit" value="'.$mvars[105019].'" '.str_replace('{form_name}',$_NL['modkey'].'template',$mvars[107019]).' />';

		// complete html
		$_NL['temp']['templateselect']['html']['complete'] = $_NL['temp']['templateselect']['html']['form_start'].
																									  	str_replace(
																									  			array(
																									          '{emailtemplate_select}',
																									          '{emailtemplate_label}',
																									          '{emailtemplate_submit}'
																									        ),
																									        array(
																									          "\n".implode("\n",$_NL['temp']['templateselect']['html']['form_select']),
																									          $_NL['temp']['templateselect']['html']['form_label'],
																									          $_NL['temp']['templateselect']['html']['form_submit']."\n"
																									        ),
																									        $mvars[19]).
																								        $_NL['temp']['templateselect']['html']['form_end'];

	  $_NL['output']['list_body'] = str_replace('{emailtemplate_form}',$_NL['temp']['templateselect']['html']['complete'],$_NL['output']['list_body']);

	}
	
 
	// 	
	// template links
	// 
	if (strpos($_NL['output']['list_body'],'{emailtemplate_links}')!==false){
		$_NL['temp']['templatelinks']['html']='';
		if (is_array($_NL['temp']['templates']))
		
			$_NL['temp']['templatelinks']['html']	.=	str_replace(
																								  			array(
																								          '{url}',
																								          '{url_addon}',
																								          '{name}'
																								        ),

																								        array(
																														nl_url_creator( $con_side[$idcatside]['link'], 
																																						array(	'idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																										'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																																										'startmonth' => $_NL['config']['startmonth'],
																																										'monthback' => $_NL['config']['monthback'],
																																										'searchstring' => $_NL['temp']['searchstring'] ,
																																										'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																										'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																										'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																										'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																										'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																										'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																										'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																										'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																										'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																										'cf10' => $_NL['temp']['customfilters2']['custom10'],
																																										'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort')																																										
																																									)  
																																					),
																														nl_url_creator( '', 
																																						array(	'idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																										'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																																										'startmonth' => $_NL['config']['startmonth'],
																																										'monthback' => $_NL['config']['monthback'],
																																										'searchstring' => $_NL['temp']['searchstring'] ,
																																										'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																										'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																										'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																										'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																										'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																										'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																										'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																										'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																										'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																										'cf10' => $_NL['temp']['customfilters2']['custom10'],
																																										'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort')
																																									)  
																																					),
																								          $mvars[102019]
																								        ),
																								        $_NL['temp']['tpl_links']);

			foreach ( $_NL['temp']['templates'] as $k => $v)
				$_NL['temp']['templatelinks']['html']	.=	str_replace(
																									  			array(
																									          '{url}',
																									          '{url_addon}',
																									          '{name}'
																									        ),

																									        array(
																															nl_url_creator( $con_side[(!empty($mvars[108019])?$mvars[108019]:$idcatside)]['link'], 
																																							array(	'idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																											'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																																											'startmonth' => $_NL['config']['startmonth'],
																																											'monthback' => $_NL['config']['monthback'],
																																											'template' => $k,
																																											'searchstring' => $_NL['temp']['searchstring'] ,
																																											'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																											'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																											'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																											'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																											'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																											'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																											'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																											'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																											'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																											'cf10' => $_NL['temp']['customfilters2']['custom10'],
																																											'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort')
																																										)  
																																						),
																															nl_url_creator( '', 
																																							array(	'idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																											'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:''),
																																											'startmonth' => $_NL['config']['startmonth'],
																																											'monthback' => $_NL['config']['monthback'],
																																											'template' => $k,
																																											'searchstring' => $_NL['temp']['searchstring'] ,
																																											'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																											'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																											'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																											'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																											'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																											'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																											'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																											'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																											'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																											'cf10' => $_NL['temp']['customfilters2']['custom10'],
																																											'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort')
																																										)  
																																						),
																									          htmlentities($v, ENT_COMPAT, 'UTF-8')
																									        ),
																									        $_NL['temp']['tpl_links']);
				
	  $_NL['output']['list_body'] = str_replace('{emailtemplate_links}',$_NL['temp']['templatelinks']['html'],$_NL['output']['list_body']);

	
	}
	// 
	// search form
	// 
	if (strpos($_NL['output']['list_body'],'{search_form}')!==false){

		// start & end
		$_NL['temp']['search']['html']['form_start']	= '<form name="'.
																										$_NL['modkey'].'search" method="post" action="'.
																										nl_url_creator( $con_side[(!empty($mvars[108])?$mvars[108]:$idcatside)]['link'],
																																		array('template' => $_NL['temp']['template'] ,
																																					'cf1' => $_NL['temp']['customfilters2']['custom1'],
																																					'cf2' => $_NL['temp']['customfilters2']['custom2'],
																																					'cf3' => $_NL['temp']['customfilters2']['custom3'],
																																					'cf4' => $_NL['temp']['customfilters2']['custom4'],
																																					'cf5' => $_NL['temp']['customfilters2']['custom5'],
																																					'cf6' => $_NL['temp']['customfilters2']['custom6'],
																																					'cf7' => $_NL['temp']['customfilters2']['custom7'],
																																					'cf8' => $_NL['temp']['customfilters2']['custom8'],
																																					'cf9' => $_NL['temp']['customfilters2']['custom9'],
																																					'cf10' => $_NL['temp']['customfilters2']['custom10'],
																																					'sort' => $_NL['cms_wr']->getVal($_NL['modkey'].'sort'),
																																					'idnewsletter' => (($mvars['72']=='list')?$_NL['idnewslettermem']:''),
																																					'idcatsideback' => (($mvars['72']=='list' && !empty($_NL['temp']['idcatsideback']))?$_NL['temp']['idcatsideback']:'')
																																				)  ).			
																										'">';
		$_NL['temp']['search']['html']['form_end']		= '</form>';
		
		// select
		$_NL['temp']['search']['html']['form_input']  = '<input type="text" id="'.$cms_mod['key'].'searchstring" name="'.$_NL['modkey'].'searchstring" value="'.$_NL['temp']['searchstring'].'" '.$mvars[103].' />';

		// label
	  $_NL['temp']['search']['html']['form_label'] = '<label for="'.$cms_mod['key'].'searchstring" '.str_replace('{form_name}',$_NL['modkey'].'month',$mvars[104]).'>'.$mvars[101].'</label>';
	
		// submit
	  $_NL['temp']['search']['html']['form_submit'] = '<input type="submit" value="'.$mvars[100].'" '.str_replace('{form_name}',$_NL['modkey'].'month',$mvars[107]).' />';

		// complete html
		$_NL['temp']['search']['html']['complete'] = $_NL['temp']['search']['html']['form_start'].
																									  	str_replace(
																									  			array(
																									          '{search_input}',
																									          '{search_label}',
																									          '{search_submit}'
																									        ),
																									        array(
																									          "\n".$_NL['temp']['search']['html']['form_input'],
																									          $_NL['temp']['search']['html']['form_label'],
																									          $_NL['temp']['search']['html']['form_submit']."\n"
																									        ),
																									        $mvars[18]).
																								        $_NL['temp']['search']['html']['form_end'];

	  $_NL['output']['list_body'] = str_replace('{search_form}',$_NL['temp']['search']['html']['complete'],$_NL['output']['list_body']);
	
	}
	// 
	// chop
	// 
	if (strpos($_NL['output']['list_body'],'{chop}')!==false){
		preg_match_all('#\{chop\}(.*)\{/chop\}#sU',$_NL['output']['list_body'],$_NL['temp']['chopparts']);
		if (!empty($_NL['temp']['chopparts']))
	  	foreach ($_NL['temp']['chopparts'][1] as $k => $v)
	  		$_NL['output']['list_body']=str_replace(	$_NL['temp']['chopparts'][0][$k],
	  																				nl_str_chop($v, $mvars['1003'], $mvars['1004'], $mvars['1005']),
	  																				$_NL['output']['list_body']);
	  else
	  	$_NL['output']['list_body']=str_replace(array('{chop}','{/chop}'), array('',''), $_NL['output']['list_body']);
	}

  	// global if-statements
	$_NL['output']['list_body'] = nl_element_sfifstatements($_NL['output']['list_body']);
	$_NL['output']['list_body'] = str_replace('{inlinepath}',$cfg_client['htmlpath'],$_NL['output']['list_body']);

	// replace personalized elements
	if ((int) $_NL['cms_wr']->getVal($_NL['modkey'].'iduser')>0){
		$_NL['temp']['data']=array();
		$_NL['user']->loadByIduser($_NL['cms_wr']->getVal($_NL['modkey'].'iduser'));
		$_NL['temp']['data']['salutation']=$_NL['user']->getSalutation();
		$_NL['temp']['data']['firstname']=$_NL['user']->getName();
		$_NL['temp']['data']['lastname']=$_NL['user']->getSurname();
		$_NL['temp']['data']['iduser']=$receiversuid;
	} else {
		$_NL['temp']['data']=array();
		$_NL['temp']['data']['iduser']='';
		$_NL['temp']['data']['salutation']='';
		$_NL['temp']['data']['firstname']='';
		$_NL['temp']['data']['lastname']='';
	}

	foreach ($_NL['temp']['data'] as $k => $v) {
			$_NL['output']['list_body']=str_replace('{'.$k.'}',$v,nl_element_ifstatements($_NL['output']['list_body'],$_NL['temp']['data'],$k,$v));
			$_NL['temp']['html_ouput']=str_replace('{'.$k.'}',$v,nl_element_ifstatements($_NL['temp']['html_ouput'],$_NL['temp']['data'],$k,$v));
	}								


	//
	//output
	// 
	echo stripslashes($_NL['output']['list_body']);

}

  unset($adodb,$rs, $_NL, $mvars, $mod);
?>
